﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CVUT.Vorel.elasticity.controls
{
  public partial class ucMaterial : UserControl
  {
    public ucMaterial()
    {
      InitializeComponent();
    }

    private void rbIsotropic_CheckedChanged(object sender, EventArgs e)
    {
      if (rbIsotropic.Checked)
      {
        ucMaterial_iso.Visible = true;
        ucMaterial_ortho.Visible = false;
        ucMaterial_aniso.Visible = false;

        ucMaterial_iso.Enabled = true;
        ucMaterial_ortho.Enabled = false;
        ucMaterial_aniso.Enabled = false;

        if (sender == rbOrthotropic)
        {
          ucMaterial_iso.LoadL(ucMaterial_ortho.Constituent);
        }
        else if (sender == rbAnisotropic)
        {
          ucMaterial_iso.LoadL(ucMaterial_aniso.Constituent);
        }

      }
      else if (rbOrthotropic.Checked)
      {
        ucMaterial_iso.Visible = false;
        ucMaterial_ortho.Visible = true;
        ucMaterial_aniso.Visible = false;

        ucMaterial_iso.Enabled = false;
        ucMaterial_ortho.Enabled = true;
        ucMaterial_aniso.Enabled = false;

        if (sender == rbIsotropic)
        {
          ucMaterial_ortho.LoadL(ucMaterial_iso.Constituent);
        }
        else if (sender == rbAnisotropic)
        {
          ucMaterial_ortho.LoadL(ucMaterial_aniso.Constituent);
        }
      }
      else if (rbAnisotropic.Checked)
      {
        ucMaterial_iso.Visible = false;
        ucMaterial_ortho.Visible = false;
        ucMaterial_aniso.Visible = true;

        ucMaterial_iso.Enabled = false;
        ucMaterial_ortho.Enabled = false;
        ucMaterial_aniso.Enabled = true;

        if (sender == rbIsotropic)
        {
          ucMaterial_aniso.LoadL(ucMaterial_iso.Constituent);
        }
        else if (sender == rbOrthotropic)
        {
          ucMaterial_aniso.LoadL(ucMaterial_ortho.Constituent);
        }

      }
    }

    [
      Browsable(false),
      DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
    ]
    public Constituent MaterialConstituent 
    {
      get
      {
        if (rbIsotropic.Checked)
        {
          return ucMaterial_iso.Constituent;
        }
        else if (rbOrthotropic.Checked)
        {
          return ucMaterial_ortho.Constituent;
        }
        else if (rbAnisotropic.Checked)
        {
          return ucMaterial_aniso.Constituent;
        }


        else
        {
          throw new Exception("Elasticity: Controls: ucMaterial: StiffnessMatrix: wrong case!!!");
        }

      }
      set
      {
        if (value.MaterialKind == Constants.EMaterialKind.Isotropic)
        {
          rbIsotropic.Checked = true;
          ucMaterial_iso.Constituent = value;
        }
        else if (value.MaterialKind == Constants.EMaterialKind.Orthotropic)
        {
          rbOrthotropic.Checked = true;
          ucMaterial_ortho.Constituent = value;
        }
        else if (value.MaterialKind == Constants.EMaterialKind.Anisotropic)
        {
          rbAnisotropic.Checked = true;
          ucMaterial_aniso.Constituent = value;
        }
        else
        {
          throw new Exception("Elasticity: Controls: ucMaterial: StiffnessMatrix: wrong case!!!");
        }

      }
    }

    public void Clear()
    {
      if (rbIsotropic.Checked)
      {
        ucMaterial_iso.Clear();
      }
      else if (rbOrthotropic.Checked)
      {
        ucMaterial_ortho.Clear();
      }
      else if (rbAnisotropic.Checked)
      {
        ucMaterial_aniso.Clear();
      }
      //else
      //{
      //  throw new Exception("Elasticity: Controls: ucMaterial: Clear: wrong case!!!");
      //}
    }

    
    private void ucMaterial_StiffChanged(object sender, EventArgs e)
    {
      if (StiffChanged != null) StiffChanged(this, EventArgs.Empty);
    }

    public event EventHandler StiffChanged;

  }
}
