﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CVUT.Vorel.elasticity.controls
{
  public partial class ucMaterial_aniso : UserControl
  {
    Constituent _L  = new Constituent();

    public ucMaterial_aniso()
    {
      InitializeComponent();
    }

    [
     Browsable(false),
     DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
    ]
    public Constituent Constituent
    {
      get
      {
        return _L;
      }
      set 
      {
        LoadL(value);
      }
    }

    private void dtbL_ValueChanged(object sender, EventArgs e)
    {
      if (sender == dtbL01)
      {
        dtbL10.Value = dtbL01.Value;
      }
      else if (sender == dtbL02)
      {
        dtbL20.Value = dtbL02.Value;
      }
      else if (sender == dtbL03)
      {
        dtbL30.Value = dtbL03.Value;
      }
      else if (sender == dtbL04)
      {
        dtbL40.Value = dtbL04.Value;
      }
      else if (sender == dtbL05)
      {
        dtbL50.Value = dtbL05.Value;
      }
      else if (sender == dtbL12)
      {
        dtbL21.Value = dtbL12.Value;
      }
      else if (sender == dtbL13)
      {
        dtbL31.Value = dtbL13.Value;
      }
      else if (sender == dtbL14)
      {
        dtbL41.Value = dtbL14.Value;
      }
      else if (sender == dtbL15)
      {
        dtbL51.Value = dtbL15.Value;
      }
      else if (sender == dtbL23)
      {
        dtbL32.Value = dtbL23.Value;
      }
      else if (sender == dtbL24)
      {
        dtbL42.Value = dtbL24.Value;
      }
      else if (sender == dtbL25)
      {
        dtbL52.Value = dtbL25.Value;
      }
      else if (sender == dtbL34)
      {
        dtbL43.Value = dtbL34.Value;
      }
      else if (sender == dtbL35)
      {
        dtbL53.Value = dtbL35.Value;
      }
      else if (sender == dtbL45)
      {
        dtbL54.Value = dtbL45.Value;
      }

      _L.StiffnessMatrix[0, 0] = dtbL00.Value;
      _L.StiffnessMatrix[0, 1] = dtbL01.Value;
      _L.StiffnessMatrix[0, 2] = dtbL02.Value;
      _L.StiffnessMatrix[0, 3] = dtbL03.Value;
      _L.StiffnessMatrix[0, 4] = dtbL04.Value;
      _L.StiffnessMatrix[0, 5] = dtbL05.Value;

      _L.StiffnessMatrix[1, 0] = dtbL10.Value;
      _L.StiffnessMatrix[1, 1] = dtbL11.Value;
      _L.StiffnessMatrix[1, 2] = dtbL12.Value;
      _L.StiffnessMatrix[1, 3] = dtbL13.Value;
      _L.StiffnessMatrix[1, 4] = dtbL14.Value;
      _L.StiffnessMatrix[1, 5] = dtbL15.Value;

      _L.StiffnessMatrix[2, 0] = dtbL20.Value;
      _L.StiffnessMatrix[2, 1] = dtbL21.Value;
      _L.StiffnessMatrix[2, 2] = dtbL22.Value;
      _L.StiffnessMatrix[2, 3] = dtbL23.Value;
      _L.StiffnessMatrix[2, 4] = dtbL24.Value;
      _L.StiffnessMatrix[2, 5] = dtbL25.Value;

      _L.StiffnessMatrix[3, 0] = dtbL30.Value;
      _L.StiffnessMatrix[3, 1] = dtbL31.Value;
      _L.StiffnessMatrix[3, 2] = dtbL32.Value;
      _L.StiffnessMatrix[3, 3] = dtbL33.Value;
      _L.StiffnessMatrix[3, 4] = dtbL34.Value;
      _L.StiffnessMatrix[3, 5] = dtbL35.Value;

      _L.StiffnessMatrix[4, 0] = dtbL40.Value;
      _L.StiffnessMatrix[4, 1] = dtbL41.Value;
      _L.StiffnessMatrix[4, 2] = dtbL42.Value;
      _L.StiffnessMatrix[4, 3] = dtbL43.Value;
      _L.StiffnessMatrix[4, 4] = dtbL44.Value;
      _L.StiffnessMatrix[4, 5] = dtbL45.Value;

      _L.StiffnessMatrix[5, 0] = dtbL50.Value;
      _L.StiffnessMatrix[5, 1] = dtbL51.Value;
      _L.StiffnessMatrix[5, 2] = dtbL52.Value;
      _L.StiffnessMatrix[5, 3] = dtbL53.Value;
      _L.StiffnessMatrix[5, 4] = dtbL54.Value;
      _L.StiffnessMatrix[5, 5] = dtbL55.Value;

      StiffChanged(this, EventArgs.Empty);
    }

    public void LoadL(Constituent L)
    {
      if (L.MaterialKind == Constants.EMaterialKind.FullyAnisotropic)
      {
        throw new Exception("Elasticity: Controls: ucMaterial_aniso: LoadL: material has fully anisotrphy!!!");
      }

      _L = L;

      dtbL00.Value = _L.StiffnessMatrix[0, 0];
      dtbL11.Value = _L.StiffnessMatrix[1, 1];
      dtbL22.Value = _L.StiffnessMatrix[2, 2];
      dtbL33.Value = _L.StiffnessMatrix[3, 3];
      dtbL44.Value = _L.StiffnessMatrix[4, 4];
      dtbL55.Value = _L.StiffnessMatrix[5, 5];

      dtbL01.Value = dtbL10.Value = _L.StiffnessMatrix[0, 1];
      dtbL02.Value = dtbL20.Value = _L.StiffnessMatrix[0, 2];
      dtbL03.Value = dtbL30.Value = _L.StiffnessMatrix[0, 3];
      dtbL04.Value = dtbL40.Value = _L.StiffnessMatrix[0, 4];
      dtbL05.Value = dtbL50.Value = _L.StiffnessMatrix[0, 5];

      dtbL12.Value = dtbL21.Value = _L.StiffnessMatrix[1, 2];
      dtbL13.Value = dtbL31.Value = _L.StiffnessMatrix[1, 3];
      dtbL14.Value = dtbL41.Value = _L.StiffnessMatrix[1, 4];
      dtbL15.Value = dtbL51.Value = _L.StiffnessMatrix[1, 5];

      dtbL23.Value = dtbL32.Value = _L.StiffnessMatrix[2, 3];
      dtbL24.Value = dtbL42.Value = _L.StiffnessMatrix[2, 4];
      dtbL25.Value = dtbL52.Value = _L.StiffnessMatrix[2, 5];

      dtbL34.Value = dtbL43.Value = _L.StiffnessMatrix[3, 4];
      dtbL35.Value = dtbL53.Value = _L.StiffnessMatrix[3, 5];

      dtbL45.Value = dtbL54.Value = _L.StiffnessMatrix[4, 5];


    }

    public void Clear()
    {
      dtbL00.Clear();
      dtbL01.Clear();
      dtbL02.Clear();
      dtbL03.Clear();
      dtbL04.Clear();
      dtbL05.Clear();

      dtbL10.Clear();
      dtbL11.Clear();
      dtbL12.Clear();
      dtbL13.Clear();
      dtbL14.Clear();
      dtbL15.Clear();

      dtbL20.Clear();
      dtbL21.Clear();
      dtbL22.Clear();
      dtbL23.Clear();
      dtbL24.Clear();
      dtbL25.Clear();

      dtbL30.Clear();
      dtbL31.Clear();
      dtbL32.Clear();
      dtbL33.Clear();
      dtbL34.Clear();
      dtbL35.Clear();

      dtbL40.Clear();
      dtbL41.Clear();
      dtbL42.Clear();
      dtbL43.Clear();
      dtbL44.Clear();
      dtbL45.Clear();

      dtbL50.Clear();
      dtbL51.Clear();
      dtbL52.Clear();
      dtbL53.Clear();
      dtbL54.Clear();
      dtbL55.Clear();
    }

    public event EventHandler StiffChanged;

  }
}
