﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace CVUT.Vorel.elasticity
{
  public class Matrix : Constituent
  {

    public Matrix()
      : base()
    {
    }
    public Matrix(Tensor StiffMatrix)
      : base(StiffMatrix)
    {
    }
    public Matrix(double E, double ny)
      : base(E, ny)
    {
    }
    public Matrix(Matrix oa)
      : base(oa)
    {
    }
    /////////////////////////////////////////////////////////////////////////////////////////////
    public void ClearMatrix()
    {
      base.ClearConstituent();
    }
    public XmlElement ToXml(XmlDocument xmldoc)
    {
      XmlElement _Matrix = xmldoc.CreateElement("matrix");
      _Matrix.AppendChild(StiffnessMatrix.ToXml(xmldoc, "stiffness_matrix"));

      return _Matrix;
    }
    public void FromXml(XmlNode xmlnode)
    {
      this.ClearMatrix();

      if (!(xmlnode.ChildNodes.Count == 1))
      {
        throw new Exception("Elasticity: xml: matrix: wrong number of children!!!");
      }
      else
      {
        if (!(this.StiffnessMatrix.FromXml(xmlnode.ChildNodes[0]) == "stiffness_matrix"))
        {
          throw new Exception("Elasticity: xml: matrix: there isn't tensor of heat conduction!!!");
        }
      }
    }

  }
}
