﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.IO;

namespace CVUT.Vorel
{
  public class Save
  {
    private static XmlDocument _xmldoc;
    private static XmlElement _Project;

    public static void FileToSave(heat.Matrix matrix, List<heat.Inclusion> incl_list, string projectname, string filename)
    {
      _xmldoc = new XmlDocument();
      XmlAttribute _atrib;

      _Project = _xmldoc.CreateElement("homogenization");

      _atrib = _xmldoc.CreateAttribute("name");
      _atrib.Value = projectname;
      _Project.SetAttributeNode(_atrib);

      _atrib = _xmldoc.CreateAttribute("type");
      _atrib.Value = "heat";
      _Project.SetAttributeNode(_atrib);

      //XML declaration
      _xmldoc.InsertBefore(_xmldoc.CreateXmlDeclaration("1.0", Encoding.Unicode.WebName, null), _xmldoc.DocumentElement);

      //Matrix
      _Project.AppendChild(matrix.ToXml(_xmldoc));

      //Inclusions
      XmlElement _Inclusion = _xmldoc.CreateElement("inclusions");
      for (int i = 0; i < incl_list.Count; i++)
      {
        _Inclusion.AppendChild(incl_list[i].ToXml(_xmldoc));
      }
      _Project.AppendChild(_Inclusion);

      _xmldoc.AppendChild(_Project);

      //XML saving
      System.Xml.XmlTextWriter writer = new System.Xml.XmlTextWriter(filename, Encoding.Unicode);
      writer.Formatting = System.Xml.Formatting.Indented; // we don't want it all in one line
      _xmldoc.WriteTo(writer);
      writer.Close();
    }
    public static void FileToSave(elasticity.Matrix matrix, List<elasticity.Inclusion> incl_list, string projectname, string filename)
    {
      _xmldoc = new XmlDocument();
      XmlAttribute _atrib;

      _Project = _xmldoc.CreateElement("homogenization");

      _atrib = _xmldoc.CreateAttribute("name");
      _atrib.Value = projectname;
      _Project.SetAttributeNode(_atrib);

      _atrib = _xmldoc.CreateAttribute("type");
      _atrib.Value = "elasticity";
      _Project.SetAttributeNode(_atrib);

      //XML declaration
      _xmldoc.InsertBefore(_xmldoc.CreateXmlDeclaration("1.0", Encoding.Unicode.WebName, null), _xmldoc.DocumentElement);

      //Matrix
      _Project.AppendChild(matrix.ToXml(_xmldoc));

      //Inclusions
      XmlElement _Inclusion = _xmldoc.CreateElement("inclusions");
      for (int i = 0; i < incl_list.Count; i++)
      {
        _Inclusion.AppendChild(incl_list[i].ToXml(_xmldoc));
      }
      _Project.AppendChild(_Inclusion);


      _xmldoc.AppendChild(_Project);

      //XML saving
      System.Xml.XmlTextWriter writer = new System.Xml.XmlTextWriter(filename, Encoding.Unicode);
      writer.Formatting = System.Xml.Formatting.Indented; // we don't want it all in one line
      _xmldoc.WriteTo(writer);
      writer.Close();

    }
    public static void FileToSave(elasticity.Matrix matrix, elasticity.Tow tow, string projectname, string filename)
    {
      _xmldoc = new XmlDocument();
      XmlAttribute _atrib;

      _Project = _xmldoc.CreateElement("homogenization");

      _atrib = _xmldoc.CreateAttribute("name");
      _atrib.Value = projectname;
      _Project.SetAttributeNode(_atrib);

      _atrib = _xmldoc.CreateAttribute("type");
      _atrib.Value = "elasticity";
      _Project.SetAttributeNode(_atrib);

      //XML declaration
      _xmldoc.InsertBefore(_xmldoc.CreateXmlDeclaration("1.0", Encoding.Unicode.WebName, null), _xmldoc.DocumentElement);

      //Matrix
      _Project.AppendChild(matrix.ToXml(_xmldoc));

      //Tow
      _Project.AppendChild(tow.ToXmlh(_xmldoc));

      _xmldoc.AppendChild(_Project);

      //XML saving
      System.Xml.XmlTextWriter writer = new System.Xml.XmlTextWriter(filename, Encoding.Unicode);
      writer.Formatting = System.Xml.Formatting.Indented; // we don't want it all in one line
      _xmldoc.WriteTo(writer);
      writer.Close();

    }
    public static void FileToSave(heat.Matrix matrix, heat.Tow tow, string projectname, string filename)
    {
      _xmldoc = new XmlDocument();
      XmlAttribute _atrib;

      _Project = _xmldoc.CreateElement("homogenization");

      _atrib = _xmldoc.CreateAttribute("name");
      _atrib.Value = projectname;
      _Project.SetAttributeNode(_atrib);

      _atrib = _xmldoc.CreateAttribute("type");
      _atrib.Value = "heat";
      _Project.SetAttributeNode(_atrib);

      //XML declaration
      _xmldoc.InsertBefore(_xmldoc.CreateXmlDeclaration("1.0", Encoding.Unicode.WebName, null), _xmldoc.DocumentElement);

      //Matrix
      _Project.AppendChild(matrix.ToXml(_xmldoc));

      //Tow
      _Project.AppendChild(tow.ToXmlh(_xmldoc));

      _xmldoc.AppendChild(_Project);

      //XML saving
      System.Xml.XmlTextWriter writer = new System.Xml.XmlTextWriter(filename, Encoding.Unicode);
      writer.Formatting = System.Xml.Formatting.Indented; // we don't want it all in one line
      _xmldoc.WriteTo(writer);
      writer.Close();

    }


  }
}
