﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CVUT.Vorel;

namespace CVUT.Vorel.heat.controls
{
  public partial class ucMaterial : UserControl
  {
    private Constituent _K = new Constituent();

    public ucMaterial()
    {
      InitializeComponent();
    }    

    private void rbIsotropic_CheckedChanged(object sender, EventArgs e)
    {
      if (rbIsotropic.Checked)
      {
        dtbHC00.Enabled = true;
        dtbHC01.Enabled = false;
        dtbHC02.Enabled = false;
        dtbHC11.Enabled = false;
        dtbHC12.Enabled = false;
        dtbHC22.Enabled = false;
        dtbHC01.Value = 0;
        dtbHC02.Value = 0;
        dtbHC12.Value = 0;
        dtbHC10.Value = 0;
        dtbHC20.Value = 0;
        dtbHC21.Value = 0;
        dtbHC11.Value = dtbHC00.Value;
        dtbHC22.Value = dtbHC00.Value;

      }
      else if (rbOrthotropic.Checked)
      {
        dtbHC00.Enabled = true;
        dtbHC01.Enabled = false;
        dtbHC02.Enabled = false;
        dtbHC11.Enabled = true;
        dtbHC12.Enabled = false;
        dtbHC22.Enabled = true;
        dtbHC01.Value = 0;
        dtbHC02.Value = 0;
        dtbHC12.Value = 0;
        dtbHC10.Value = 0;
        dtbHC20.Value = 0;
        dtbHC21.Value = 0;

      }
      else if (rbAnisotropic.Checked)
      {
        dtbHC00.Enabled = true;
        dtbHC01.Enabled = true;
        dtbHC02.Enabled = true;
        dtbHC11.Enabled = true;
        dtbHC12.Enabled = true;
        dtbHC22.Enabled = true;
      }

      dtbK_ValueChanged(sender, e);
    }

    private void dtbK_ValueChanged(object sender, EventArgs e)
    {
      if ((sender == dtbHC00) && (rbIsotropic.Checked))
      {
        dtbHC11.Value = dtbHC00.Value;
        dtbHC22.Value = dtbHC00.Value;
      }
      if (sender == dtbHC01)
        dtbHC10.Value = dtbHC01.Value;
      if (sender == dtbHC02)
        dtbHC20.Value = dtbHC02.Value;
      if (sender == dtbHC12)
        dtbHC21.Value = dtbHC12.Value;

      _K.HeatConducTensor[0, 0] = dtbHC00.Value;
      _K.HeatConducTensor[0, 1] = dtbHC01.Value;
      _K.HeatConducTensor[0, 2] = dtbHC02.Value;
      _K.HeatConducTensor[1, 0] = dtbHC10.Value;
      _K.HeatConducTensor[1, 1] = dtbHC11.Value;
      _K.HeatConducTensor[1, 2] = dtbHC12.Value;
      _K.HeatConducTensor[2, 0] = dtbHC20.Value;
      _K.HeatConducTensor[2, 1] = dtbHC21.Value;
      _K.HeatConducTensor[2, 2] = dtbHC22.Value;
    }

    public void LoadK(Constituent K)
    {
      _K = K;
      dtbHC00.Value = _K.HeatConducTensor[0, 0];
      dtbHC01.Value = _K.HeatConducTensor[0, 1];
      dtbHC02.Value = _K.HeatConducTensor[0, 2];
      dtbHC10.Value = _K.HeatConducTensor[1, 0];
      dtbHC11.Value = _K.HeatConducTensor[1, 1];
      dtbHC12.Value = _K.HeatConducTensor[1, 2];
      dtbHC20.Value = _K.HeatConducTensor[2, 0];
      dtbHC21.Value = _K.HeatConducTensor[2, 1];
      dtbHC22.Value = _K.HeatConducTensor[2, 2];

      switch (_K.MaterialKind)
      {
        case Constants.EMaterialKind.Isotropic:
          rbIsotropic.Checked = true;
          break;
        case Constants.EMaterialKind.Orthotropic:
          rbOrthotropic.Checked = true;
          break;
        case Constants.EMaterialKind.Anisotropic:
          rbAnisotropic.Checked = true;
          break;
      }
    }

    public void Clear()
    {
      rbIsotropic.Checked = false;
      rbOrthotropic.Checked = false;
      rbAnisotropic.Checked = false;

      dtbHC00.Clear();
      dtbHC01.Clear();
      dtbHC02.Clear();
      dtbHC10.Clear();
      dtbHC11.Clear();
      dtbHC12.Clear();
      dtbHC20.Clear();
      dtbHC21.Clear();
      dtbHC22.Clear();
    }

  }
}
