﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace CVUT.Vorel.heat
{
  public class Matrix : Constituent
  {

    public Matrix()
      : base()
    {
    }
    public Matrix(double HeatCoef)
      : base(HeatCoef)
    {
    }
    public Matrix(Tensor HeatCoef)
      : base(HeatCoef)
    {
    }
    public Matrix(double HeatCoef0, double HeatCoef1, double HeatCoef2)
      : base(HeatCoef0, HeatCoef1, HeatCoef2)
    {
    }
    public Matrix(Matrix oa)
      : base(oa)
    {
    }
    /////////////////////////////////////////////////////////////////////////////////////////////
    public void ClearMatrix()
    {
      base.ClearConstituent();
    }
    public XmlElement ToXml(XmlDocument xmldoc)
    {
      XmlElement _Matrix = xmldoc.CreateElement("matrix");
      _Matrix.AppendChild(HeatConducTensor.ToXml(xmldoc, "heat_conduction"));
      
      return _Matrix;
    }
    public void FromXml(XmlNode xmlnode)
    {
      this.ClearMatrix();

      if (!(xmlnode.ChildNodes.Count == 1))
      {
        throw new Exception("xml: matrix: wrong number of children!!!");
      }
      else
      {
        if (!(this.HeatConducTensor.FromXml(xmlnode.ChildNodes[0]) == "heat_conduction"))
        {
          throw new Exception("xml: matrix: there isn't tensor of heat conduction!!!");
        }
      }      
    }

  }
}
