﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CVUT.Vorel
{
  class CommandLineInput
  {
    public static bool CommandInput(string[] args)
    {

      if (args.Length != 2)
      {
        System.IO.TextWriter tw = new System.IO.StreamWriter(Constants.errorFile, true);
        tw.WriteLine("CommandInput: Wrong number of input arguments = " + args.Length.ToString());
        tw.Close();

        return (false);
      }

      try
      {
        //create a reader and open a file
        System.IO.TextReader tr = new System.IO.StreamReader(args[0]);
        // create a writer and open the file
        System.IO.TextWriter tw_solver = new System.IO.StreamWriter(args[1]);
        string line;

        while ((line = tr.ReadLine()) != null)
        {
          if (line != null)
          {
            int nItems_definition = 2; //number of words in deffinition line
            //1st "Heat" or "Elasticity"
            //2nd "twoPhase" or "threePhase"
            int nItems_input;
            Tensor input;
            string[] items_in_line_input;



            // string definition
            string[] items_in_line_definition = new string[nItems_definition];

            items_in_line_definition = Common.SplittingLine(line, nItems_definition); // Splitting line
            
            //line of parameters
            while ((line = tr.ReadLine()) != null) { if (line != null) break; }


            switch (Common.GetProblemKind(items_in_line_definition[0])) //determination of elasticity or heat
            {
              case Constants.EProblemKind.Elasticity:

                nItems_input = 19;
                input = new Tensor(nItems_input);
                items_in_line_input = new string[nItems_input];


                // input numbers definition - consequent line
                items_in_line_input = Common.SplittingLine(line, nItems_input); // Splitting line
                input = Common.StringArrayToTensor(items_in_line_input, nItems_input); //Read data

                ProblemSolving.WeaveCompositeElasticity(input, items_in_line_definition[1], tw_solver);

                break;
              case Constants.EProblemKind.Heat:

                nItems_input = 15;
                input = new Tensor(nItems_input);
                items_in_line_input = new string[nItems_input];


                // input numbers definition - consequent line
                items_in_line_input = Common.SplittingLine(line, nItems_input); // Splitting line
                input = Common.StringArrayToTensor(items_in_line_input, nItems_input); //Read data

                ProblemSolving.WeaveCompositeHeat(input, items_in_line_definition[1], tw_solver);

                break;
              default:
                throw new Exception("CommandInput: Wrong key word!!!");
            }
          }
        }


        tr.Close();
        tw_solver.Close();
      }
      catch (Exception exc)
      {
        System.IO.TextWriter tw = new System.IO.StreamWriter(Constants.errorFile, true);
        tw.WriteLine(exc.Message);
        tw.Close();
      }

      return true;
    }


  }
}
