﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CVUT.Vorel
{
  public class Constants
  {
    public const string errorFile = "error.out";
    public const double SMALL = 1e-10;
    public const double ZERO = 1e-20;
    public const double ZEROITER = 1e-10;
    public const double INFINITY = Double.PositiveInfinity;
    public enum EMaterialKind { Isotropic, Orthotropic, Anisotropic, FullyAnisotropic };
    public enum EInclusionKind { Sphere, Cylinder, EllipticCylinder, PennyShape, Ellipsoid, Empty };
    public enum EStuctKind { Matrix, Inclusion, Tow, Result, Empty };
    public enum EProblemKind { Heat, Elasticity, Empty };
    /////////////////////////////////////////////////////////////////////////////////////////////
    public static class Separators
    {
      public static string DecimalSeparator;
      public static string BadDecimalSeparator;
      public static System.Globalization.CultureInfo FormatProvider = new System.Globalization.CultureInfo("en-US");

      static Separators()
      {
        DecimalSeparator = FormatProvider.NumberFormat.NumberDecimalSeparator;
        if (DecimalSeparator == ",")
          BadDecimalSeparator = ".";
        else
          BadDecimalSeparator = ",";
      }
    }
    ///////////////////////////////////////////////////////////////////////////////////////////// 
  }
}
