﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace CVUT.Vorel
{
  /****************************************************
  *                                                   *               
  * FILE: 	==== Tensor.cpp ====					            *   
  *                                                   *
  * Contains class for tensor and some operators      *
  * with them                                         *
  *                                                   *
  * Authors:           Jan Skocek, Jan Vorel			    *
  * Latest update:     2006							              *
  *                                                   *
  *****************************************************/

  public class Tensor
  {
    private int order, n_lines, n_columns, n_lines2, n_columns2;
    private double[] x;
    /////////////////////////////////////////////////////////////////////////////////////////////
    public Tensor(int olines)
    {
      order = 0;
      n_lines = 0;
      n_columns = 0;
      n_lines2 = 0;
      n_columns2 = 0;

      int i;

      order = 1;
      n_lines = olines;
      x = new double[n_lines];
      for (i = 0; i < n_lines; i++)
        x[i] = 0.0;
    }
    public Tensor(int olines, int ocolumns)
    {

      order = 0;
      n_lines = 0;
      n_columns = 0;
      n_lines2 = 0;
      n_columns2 = 0;

      int i;

      if (ocolumns == 0)
      {
        order = 1;
        n_lines = olines;
        x = new double[n_lines];
        for (i = 0; i < n_lines; i++)
          x[i] = 0;
      }
      else
      {
        order = 2;
        n_lines = olines;
        n_columns = ocolumns;
        x = new double[n_lines * n_columns];
        for (i = 0; i < n_lines * n_columns; i++)
          x[i] = 0.0;
      }
    }
    public Tensor(int olines, int ocolumns, int olines2)
    {

      order = 0;
      n_lines = 0;
      n_columns = 0;
      n_lines2 = 0;
      n_columns2 = 0;
      x = null;

      int i;

      order = 3;
      n_lines = olines;
      n_columns = ocolumns;
      n_lines2 = olines2;
      x = new double[n_lines * n_columns * n_lines2];
      for (i = 0; i < n_lines * n_columns * n_lines2; i++) x[i] = 0.0;
    }
    public Tensor(int olines, int ocolumns, int olines2, int ocolumns2)
    {

      order = 0;
      n_lines = 0;
      n_columns = 0;
      n_lines2 = 0;
      n_columns2 = 0;
      x = null;

      int i;

      order = 4;
      n_lines = olines;
      n_columns = ocolumns;
      n_lines2 = olines2;
      n_columns2 = ocolumns2;
      x = new double[n_lines * n_columns * n_lines2 * n_columns2];
      for (i = 0; i < n_lines * n_columns * n_lines2 * n_columns2; i++)
        x[i] = 0.0;
    }
    public Tensor(Tensor oa)
    {

      int i;

      order = oa.order;
      n_lines = oa.n_lines;
      n_columns = oa.n_columns;
      n_lines2 = oa.n_lines2;
      n_columns2 = oa.n_columns2;

      switch (oa.order)
      {
        case 1:
          x = new double[n_lines];
          for (i = 0; i < n_lines; i++) x[i] = oa.x[i];
          break;
        case 2:
          x = new double[n_lines * n_columns];
          for (i = 0; i < n_lines * n_columns; i++) x[i] = oa.x[i];
          break;
        case 3:
          x = new double[n_lines * n_columns * n_lines2];
          for (i = 0; i < n_lines * n_columns * n_columns2; i++) x[i] = oa.x[i];
          break;
        case 4:
          x = new double[n_lines * n_columns * n_lines2 * n_columns2];
          for (i = 0; i < n_lines * n_columns * n_lines2 * n_columns2; i++) x[i] = oa.x[i];
          break;
        default:
          throw new Exception("Tensor: conctructor: invalid Tensor order!");
      }
    }
    /////////////////////////////////////////////////////////////////////////////////////////////
    public int which_order
    {
      get
      {
        return order;
      }
    }
    public int how_many_lines
    {
      get
      {
        return n_lines;
      }
    }
    public int how_many_lines2
    {
      get
      {
        return n_lines2;
      }
    }
    public int how_many_columns
    {
      get
      {
        return n_columns;
      }
    }
    public int how_many_columns2
    {
      get
      {
        return n_columns2;
      }
    }

    public double value(int oline)
    {
      if (order != 1)
        throw new Exception("value: invalid Tensor order!");
      if (oline > (n_lines - 1) || (oline < 0))
        throw new Exception("value: invalid line index!");
      return x[oline];
    }
    public double value(int oline, int ocolumn)
    {

      if (order != 2)
        throw new Exception("value: invalid Tensor order!");
      if (oline > (n_lines - 1) || ocolumn > (n_columns - 1) || oline < 0 || ocolumn < 0)
      {
        throw new Exception("value: invalid line or column index!");
      }
      return x[oline * n_columns + ocolumn];
    }
    public double value(int oline, int ocolumn, int oline2)
    {

      if (order != 3)
        throw new Exception("value: invalid Tensor order!");
      if (oline > (n_lines - 1) || ocolumn > (n_columns - 1) || oline2 > (n_lines2 - 1) || oline < 0 || ocolumn < 0 || oline2 < 0)
      {
        throw new Exception("value: invalid line or column index!");
      }
      return x[oline * n_columns * n_lines2 + ocolumn * n_lines2 + oline2];
    }
    public double value(int oline, int ocolumn, int oline2, int ocolumn2)
    {

      if (order != 4)
        throw new Exception("value: invalid Tensor order!");
      if (oline > (n_lines - 1) || ocolumn > (n_columns - 1) || oline2 > (n_lines2 - 1) || ocolumn2 > (n_columns2 - 1) || oline < 0 || ocolumn < 0 || ocolumn2 < 0 || oline2 < 0)
      {
        throw new Exception("value: invalid line or column index!");
      }
      return x[oline * n_columns * n_lines2 * n_columns2 + ocolumn * n_lines2 * n_columns2 + oline2 * n_columns2 + ocolumn2];
    }

    public double this[int oline]
    {
      get
      {
        if (order != 1)
          throw new Exception("Tensor: operator(): invalid Tensor order!");
        if (oline > (n_lines - 1) || (oline < 0))
        {
          throw new Exception("Tensor: operator(): invalid line index!");
        }
        return x[oline];
      }
      set
      {
        if (order != 1)
          throw new Exception("Tensor: operator(): invalid Tensor order!");
        if (oline > (n_lines - 1) || (oline < 0))
        {
          throw new Exception("Tensor: operator(): invalid line index!");
        }
        x[oline] = value;
      }
    }
    public double this[int oline, int ocolumn]
    {
      get
      {

        if (order != 2)
        {
          throw new Exception("Tensor: operator(): invalid Tensor order!");
        }
        if (oline > (n_lines - 1) || ocolumn > (n_columns - 1) || oline < 0 || ocolumn < 0)
        {
          throw new Exception("Tensor: operator(): invalid line or column index!");
        }
        return x[oline * n_columns + ocolumn];
      }
      set
      {

        if (order != 2)
        {
          throw new Exception("Tensor: operator(): invalid Tensor order!\n");
        }
        if (oline > (n_lines - 1) || ocolumn > (n_columns - 1) || oline < 0 || ocolumn < 0)
        {
          throw new Exception("Tensor: operator(): invalid line or column index!");
        }
        x[oline * n_columns + ocolumn] = value;
      }
    }
    public double this[int oline, int ocolumn, int oline2]
    {
      get
      {
        if (order != 3)
        {
          throw new Exception("Tensor: operator(): invalid Tensor order!\n");
        }
        if (oline > (n_lines - 1) || ocolumn > (n_columns - 1) || oline2 > (n_lines2 - 1) || oline < 0 || ocolumn < 0 || oline2 < 0)
        {
          throw new Exception("Tensor: operator(): invalid line or column index!");
        }
        return x[oline * n_columns * n_lines2 + ocolumn * n_lines2 + oline2];
      }
      set
      {
        if (order != 3)
        {
          throw new Exception("Tensor: operator(): invalid Tensor order!");
        }
        if (oline > (n_lines - 1) || ocolumn > (n_columns - 1) || oline2 > (n_lines2 - 1) || oline < 0 || ocolumn < 0 || oline2 < 0)
        {
          throw new Exception("Tensor: operator(): invalid line or column index!");
        }
        x[oline * n_columns * n_lines2 + ocolumn * n_lines2 + oline2] = value;
      }
    }
    public double this[int oline, int ocolumn, int oline2, int ocolumn2]
    {
      get
      {

        if (order != 4)
        {
          throw new Exception("Tensor: operator(): invalid Tensor order!");
        }
        if (oline > (n_lines - 1) || ocolumn > (n_columns - 1) || oline2 > (n_lines2 - 1) || ocolumn2 > (n_columns2 - 1) || oline < 0 || ocolumn < 0 || ocolumn2 < 0 || oline2 < 0)
        {
          throw new Exception("Tensor: operator(): invalid line or column index!");
        }
        return x[oline * n_columns * n_lines2 * n_columns2 + ocolumn * n_lines2 * n_columns2 + oline2 * n_columns2 + ocolumn2];
      }
      set
      {

        if (order != 4)
        {
          throw new Exception("Tensor: operator(): invalid Tensor order!");
        }
        if (oline > (n_lines - 1) || ocolumn > (n_columns - 1) || oline2 > (n_lines2 - 1) || ocolumn2 > (n_columns2 - 1) || oline < 0 || ocolumn < 0 || ocolumn2 < 0 || oline2 < 0)
        {
          throw new Exception("Tensor: operator(): invalid line or column index!");
        }
        x[oline * n_columns * n_lines2 * n_columns2 + ocolumn * n_lines2 * n_columns2 + oline2 * n_columns2 + ocolumn2] = value;
      }
    }

    public static Tensor operator +(Tensor oleft, Tensor oright)
    {

      if (oleft.which_order != oright.which_order)
      {
        throw new Exception("Tensor: operator+: invalid Tensors order!");
      }
      if ((oleft.how_many_lines != oright.how_many_lines) || (oleft.how_many_columns != oright.how_many_columns) || (oleft.how_many_lines2 != oright.how_many_lines2) || (oleft.how_many_columns2 != oright.how_many_columns2))
      {
        throw new Exception("Tensor: operator+: invalid Tensors size!");
      }

      int i, j, k, l;

      Tensor SUM = new Tensor(oleft);

      switch (SUM.which_order)
      {
        case 1:
          for (i = 0; i < oleft.how_many_lines; i++)
          {
            SUM[i] = oleft[i] + oright[i];
          }
          break;
        case 2:
          for (i = 0; i < oleft.how_many_lines; i++)
          {
            for (j = 0; j < oleft.how_many_columns; j++)
            {
              SUM[i, j] = oleft[i, j] + oright[i, j];
            }
          }
          break;
        case 3:
          for (i = 0; i < oleft.how_many_lines; i++)
          {
            for (j = 0; j < oleft.how_many_columns; j++)
            {
              for (k = 0; k < oleft.how_many_lines2; k++)
              {
                SUM[i, j, k] = oleft[i, j, k] + oright[i, j, k];
              }
            }
          }
          break;
        case 4:
          for (i = 0; i < oleft.how_many_lines; i++)
          {
            for (j = 0; j < oleft.how_many_columns; j++)
            {
              for (k = 0; k < oleft.how_many_lines2; k++)
              {
                for (l = 0; l < oleft.how_many_columns2; l++)
                {
                  SUM[i, j, k, l] = oleft[i, j, k, l] + oright[i, j, k, l];
                }
              }
            }
          }
          break;
        default:
          throw new Exception("Tensor: operator+: invalid Tensors order!");
      }
      return SUM;
    }
    public static Tensor operator -(Tensor oleft, Tensor oright)
    {

      if (oleft.which_order != oright.which_order)
      {
        throw new Exception("Tensor: operator+: invalid Tensors order!");
      }
      if ((oleft.how_many_lines != oright.how_many_lines) || (oleft.how_many_columns != oright.how_many_columns) || (oleft.how_many_lines2 != oright.how_many_lines2) || (oleft.how_many_columns2 != oright.how_many_columns2))
      {
        throw new Exception("Tensor: operator+: invalid Tensors size!");
      }

      int i, j, k, l;

      Tensor Diff = new Tensor(oleft);

      switch (Diff.which_order)
      {
        case 1:
          for (i = 0; i < oleft.how_many_lines; i++)
          {
            Diff[i] = oleft[i] - oright[i];
          }
          break;
        case 2:
          for (i = 0; i < oleft.how_many_lines; i++)
          {
            for (j = 0; j < oleft.how_many_columns; j++)
            {
              Diff[i, j] = oleft[i, j] - oright[i, j];
            }
          }
          break;
        case 3:
          for (i = 0; i < oleft.how_many_lines; i++)
          {
            for (j = 0; j < oleft.how_many_columns; j++)
            {
              for (k = 0; k < oleft.how_many_lines2; k++)
              {
                Diff[i, j, k] = oleft[i, j, k] - oright[i, j, k];
              }
            }
          }
          break;
        case 4:
          for (i = 0; i < oleft.how_many_lines; i++)
          {
            for (j = 0; j < oleft.how_many_columns; j++)
            {
              for (k = 0; k < oleft.how_many_lines2; k++)
              {
                for (l = 0; l < oleft.how_many_columns2; l++)
                {
                  Diff[i, j, k, l] = oleft[i, j, k, l] - oright[i, j, k, l];
                }
              }
            }
          }
          break;
        default:
          throw new Exception("Tensor: operator+: invalid Tensors order!");
      }
      return Diff;
    }
    public static Tensor operator *(double oalpha, Tensor oright)
    {

      int i, j, k, l;

      Tensor MUL = new Tensor(oright);

      switch (MUL.which_order)
      {
        case 1:
          for (i = 0; i < oright.how_many_lines; i++)
          {
            MUL[i] = oalpha * oright[i];
          }
          break;
        case 2:
          for (i = 0; i < oright.how_many_lines; i++)
          {
            for (j = 0; j < oright.how_many_columns; j++)
            {
              MUL[i, j] = oalpha * oright[i, j];
            }
          }
          break;
        case 3:
          for (i = 0; i < oright.how_many_lines; i++)
          {
            for (j = 0; j < oright.how_many_columns; j++)
            {
              for (k = 0; k < oright.how_many_lines2; k++)
              {
                MUL[i, j, k] = oalpha * oright[i, j, k];
              }
            }
          }
          break;
        case 4:
          for (i = 0; i < oright.how_many_lines; i++)
          {
            for (j = 0; j < oright.how_many_columns; j++)
            {
              for (k = 0; k < oright.how_many_lines2; k++)
              {
                for (l = 0; l < oright.how_many_columns2; l++)
                {
                  MUL[i, j, k, l] = oalpha * oright[i, j, k, l];
                }
              }
            }
          }
          break;
        default:
          throw new Exception("Tensor: operator*: invalid Tensors order!");
      }
      return MUL;
    }
    public static Tensor operator *(Tensor oleft, Tensor oright)
    {

      if (oleft.which_order == 2 && oright.which_order == 2)
      {
        if ((oleft.how_many_columns != oright.how_many_lines))
        {
          throw new Exception("Tensor: operator*: invalid Tensors size!");
        }
      }

      if (oleft.which_order == 2 && oright.which_order == 1)
      {
        if (((oleft.how_many_columns != oright.how_many_lines)))
        {
          throw new Exception("Tensor: operator*: invalid Tensors size!");
        }
      }

      int i, j, k;


      Tensor PROD = new Tensor(oleft.how_many_lines, oright.how_many_columns);

      switch (PROD.which_order)
      {
        case 1:
          for (i = 0; i < oleft.how_many_lines; i++)
          {
            for (k = 0; k < oleft.how_many_columns; k++)
            {
              PROD[i] += oleft[i, k] * oright[k];
            }
          }


          break;
        case 2:
          for (i = 0; i < oleft.how_many_lines; i++)
          {
            for (j = 0; j < oright.how_many_columns; j++)
            {
              for (k = 0; k < oleft.how_many_columns; k++)
              {
                PROD[i, j] += oleft[i, k] * oright[k, j];
              }
            }
          }
          break;
        case 4:
          throw new Exception("Tensor: operator*: 4th order not defined yet!");
        default:
          throw new Exception("Tensor: operator*: invalid Tensors order!");
      }
      return PROD;
    }
    /////////////////////////////////////////////////////////////////////////////////////////////
    public static double MaxElement(Tensor oA)
    {
      int i;
      double maxVal = 0.0;
     
      if( oA.x.GetLength(0) < 1 )
      {
        throw new Exception("Tensor: MaxElement: Length of the tensor is 0!");
      }

      maxVal = oA.x[0];
      for (i = 1; i < oA.x.GetLength(0); i++)
      {
        if( maxVal < oA.x[i] )
        {
          maxVal = oA.x[i];
        }
      }

      return (maxVal);
    }

    public static double MaxAbsElement(Tensor oA)
    {
      int i;
      double maxVal = 0.0;

      if (oA.x.GetLength(0) < 1)
      {
        throw new Exception("Tensor: MaxElement: Length of the tensor is 0!");
      }

      maxVal = Math.Abs(oA.x[0]);
      for (i = 1; i < oA.x.GetLength(0); i++)
      {
        if (maxVal < Math.Abs(oA.x[i]))
        {
          maxVal = Math.Abs(oA.x[i]);
        }
      }

      return (maxVal);
    }

    public static double MinAbsNonZeroElement(Tensor oA)
    {
      int i;
      double minVal = double.PositiveInfinity;

      if (oA.x.GetLength(0) < 1)
      {
        throw new Exception("Tensor: MaxElement: Length of the tensor is 0!");
      }


      for (i = 0; i < oA.x.GetLength(0); i++)
      {
        if (minVal > Math.Abs(oA.x[i]) && Math.Abs(oA.x[i]) != 0)
        {
          minVal = Math.Abs(oA.x[i]);
        }
      }

      return (minVal);
    }


    public static Tensor CG(Tensor oA, Tensor ob, double prec, int maxstep)
    {

      if (oA.which_order != 2 || ob.which_order != 1 || oA.how_many_lines != oA.how_many_columns || oA.how_many_lines != ob.how_many_lines)
      {
        throw new Exception("CG: invalid Tensor size or order!");
      }

      int step = 0;
      double alpha = 0, beta = 0, dif = 10 * prec;

      Tensor x = new Tensor(ob.how_many_lines);
      Tensor r = new Tensor(ob);
      Tensor v = new Tensor(ob);
      Tensor x_old = new Tensor(x);

      while ((Math.Sqrt(dif)) > prec && step < maxstep)
      {
        alpha = Tensor.Product(r, r) / Product(v, (oA * v));
        //printf( "a=%g\n", alpha );
        x_old = x;
        x = x + (alpha * v);
        beta = 1 / (Product(r, r));
        r = r - alpha * (oA * v);
        beta *= Product(r, r);
        v = r + beta * v;
        dif = 0.0;
        step++;
        for (int i = 0; i < ob.how_many_lines; i++) dif += Math.Pow((x_old[i] - x[i]), 2.0);
      }

      return x;
    }
    public static Tensor Gauss(Tensor oA, Tensor ob)
    {

      if (oA.which_order != 2 || ob.which_order != 1 || oA.how_many_lines != oA.how_many_columns || oA.how_many_lines != ob.how_many_lines)
      {
        throw new Exception("Gauss: invalid Tensor size or order!");
      }

      Tensor A = new Tensor(oA);
      Tensor b = new Tensor(ob);
      double alpha = 0.0;

      for (int i = 0; i < (A.how_many_lines - 1); i++)
      {
        for (int k = (i + 1); k < A.how_many_lines; k++)
        {
          alpha = A[k, i] / A[i, i];
          for (int j = (i + 1); j < A.how_many_lines; j++)
            A[k, j] -= alpha * A[i, j];
          b[k] -= alpha * b[i];
        }
      }
      for (int l = (A.how_many_lines - 1); l >= 0; l--)
      {
        for (int j = (l + 1); j < A.how_many_lines; j++)
          b[l] -= A[l, j] * b[j];
        b[l] /= A[l, l];
      }

      return b;
    }
    public static Tensor GaussP(Tensor oA, Tensor ob, double eps)
    {

      if (oA.which_order != 2 || ob.which_order != 1 || oA.how_many_lines != oA.how_many_columns || oA.how_many_lines != ob.how_many_lines)
      {
        throw new Exception("GaussP: invalid Tensor size or order!");
      }

      Tensor A = new Tensor(oA);
      Tensor b = new Tensor(ob);

      double alpha = 0.0;
      int p, o;
      double max;

      for (int i = 0; i < (A.how_many_lines - 1); i++)
      {
        p = i;
        max = Math.Abs(A[i, i]);
        for (o = (i + 1); o < A.how_many_lines; o++)
          if (Math.Abs(A[o, i]) > max)
          {
            max = Math.Abs(A[o, i]);
            p = o;
          }
        if (max < eps)
        {
          throw new Exception("GaussP: constants.ZERO pivot!");
        }
        if (i != p) for (o = i; o < A.how_many_lines; o++)
          {
            max = A[p, o];
            A[p, o] = A[i, o];
            A[i, o] = max;
          }
        if (i != p)
        {
          max = b[p];
          b[p] = b[i];
          b[i] = max;
        }
        for (int k = (i + 1); k < A.how_many_lines; k++)
        {
          alpha = A[k, i] / A[i, i];
          for (int j = (i + 1); j < A.how_many_lines; j++)
            A[k, j] -= alpha * A[i, j];
          b[k] -= alpha * b[i];
        }
      }
      for (int l = (A.how_many_lines - 1); l >= 0; l--)
      {
        for (int j = (l + 1); j < A.how_many_lines; j++)
          b[l] -= A[l, j] * b[j];
        b[l] /= A[l, l];
      }

      return b;
    }
    public static Tensor GaussSeidel(Tensor oA, Tensor ob, double prec, int maxstep)
    {

      if (oA.which_order != 2 || ob.which_order != 1 || oA.how_many_lines != oA.how_many_columns || oA.how_many_lines != ob.how_many_lines)
      {
        throw new Exception("GaussSeidel: invalid Tensor size or order!");
      }

      int i, j, k = 0;
      double norm, s;

      Tensor x = new Tensor(oA.how_many_lines);

      do
      {
        norm = 0; k++;
        for (i = 0; i < oA.how_many_lines; i++)
        {
          s = ob[i];
          for (j = 0; j < oA.how_many_lines; j++)
            s -= oA[i, j] * x[j];
          s = (s + oA[i, i] * x[i]) / oA[i, i];
          norm += Math.Pow(s - x[i], 2);
          x[i] = s;
        }
        norm = Math.Sqrt(norm);
      }
      while (k <= maxstep && norm > prec);

      return x;
    }

    public static double Product(Tensor oa, Tensor ob)
    {

      int i;

      if ((oa.which_order != 1) || (ob.which_order != 1))
      {
        throw new Exception("product: invalid Tensor order!");
      }
      if (oa.how_many_lines != ob.how_many_lines)
      {
        throw new Exception("product: invalid Tensor size!");
      }

      double product = 0.0;

      for (i = 0; i < oa.how_many_lines; i++)
      {
        product += (oa[i] * ob[i]);
      }
      return product;
    }
    public static void randomize(Tensor oa, double omin, double omax, bool otype)
    {//type = true = diagonally symetry

      if (otype)
      {
        if (oa.which_order == 1)
        {
          throw new Exception("randomize: no diagonally symetry for 1st oder Tensor!!");
        }
        if (oa.which_order == 2 && (oa.how_many_lines != oa.how_many_columns))
        {
          throw new Exception("randomize: no diagonally symetry for non-square Tensor!!");
        }
        if (oa.which_order == 3 && (oa.how_many_lines != oa.how_many_columns || oa.how_many_lines != oa.how_many_lines2))
        {
          throw new Exception("randomize: no diagonally symetry for non-square Tensor!!");
        }
        if (oa.which_order == 4 && (oa.how_many_lines != oa.how_many_columns || oa.how_many_lines != oa.how_many_lines2 || oa.how_many_lines != oa.how_many_columns2))
        {
          throw new Exception("randomize: no diagonally symetry for non-square Tensor!!");
        }
      }

      int i, j, k, l;
      Random rnd = new Random();

      switch (oa.which_order)
      {
        case 1:
          for (i = 0; i < oa.how_many_lines; i++)
            oa[i] = rnd.NextDouble() * (omax - omin) + omin;
          break;
        case 2:
          if (otype)
          {
            for (i = 0; i < oa.how_many_lines; i++)
            {
              for (j = i; j < oa.how_many_columns; j++)
              {
                oa[i, j] = rnd.NextDouble() * (omax - omin) + omin;
                if (i != j) oa[j, i] = oa[i, j];
              }
            }
          }
          else
          {
            for (i = 0; i < oa.how_many_lines; i++)
            {
              for (j = 0; j < oa.how_many_columns; j++)
                oa[i, j] = rnd.NextDouble() * (omax - omin) + omin;
            }
          }
          break;
        case 3:
          if (otype)
          {
            for (i = 0; i < oa.how_many_lines; i++)
            {
              for (j = i; j < oa.how_many_columns; j++)
              {
                for (k = j; k < oa.how_many_lines2; k++) oa[i, j, k] = rnd.NextDouble() * (omax - omin) + omin;
                if (i != j || i != k)
                {
                  oa[j, i, k] = oa[i, j, k];
                  oa[i, k, j] = oa[i, j, k];
                }
              }
            }
          }
          else
          {
            for (i = 0; i < oa.how_many_lines; i++)
            {
              for (j = 0; j < oa.how_many_columns; j++)
              {
                for (k = 0; k < oa.how_many_lines2; k++) oa[i, j, k] = rnd.NextDouble() * (omax - omin) + omin;
              }
            }
          }
          break;
        case 4:
          if (otype)
          {
            for (i = 0; i < oa.how_many_lines; i++)
            {
              for (j = i; j < oa.how_many_columns; j++)
              {
                for (k = j; k < oa.how_many_lines2; k++)
                {
                  for (l = k; l < oa.how_many_columns2; l++) oa[i, j, k, l] = rnd.NextDouble() * (omax - omin) + omin;
                  if (i != j || i != k || i != l)
                  {
                    oa[j, i, k, l] = oa[i, j, k, l];
                    oa[j, i, l, k] = oa[i, j, k, l];
                    oa[i, j, l, k] = oa[i, j, k, l];
                  }
                }
              }
            }
          }
          else
          {
            for (i = 0; i < oa.how_many_lines; i++)
            {
              for (j = 0; j < oa.how_many_columns; j++)
              {
                for (k = 0; k < oa.how_many_lines2; k++)
                {
                  for (l = 0; l < oa.how_many_columns2; l++) oa[i, j, k, l] = rnd.NextDouble() * (omax - omin) + omin;
                }
              }
            }
          }
          break;
        default:
          throw new Exception("Tensor: randomize: invalid Tensors order!");
      }

    }
    public static void localize(Tensor owhere, Tensor owhat, int oline, int ocolumn)
    {

      if (owhere.which_order != 2 && owhat.which_order != 2)
      {
        throw new Exception("localize: no second order Tensors!!");
      }
      if ((owhat.how_many_lines + oline) > owhere.how_many_lines || (owhat.how_many_columns + ocolumn) > owhere.how_many_columns)
      {
        throw new Exception("localize: invalid size of \"what\" Tensor!");
      }

      for (int i = 0; i < (owhat.how_many_lines); i++)
      {
        for (int j = 0; j < (owhat.how_many_columns); j++)
        {
          owhere[i + oline, j + ocolumn] += owhat[i, j];
        }
      }
    }
    public static void ludcmp(double[][] a, int n, int[] indx, out double d)
    {
      int i, imax = 0, j, k;
      double big, dum, temp;
      double[] vv;

      vv = new double[n];
      d = 1.0;
      for (i = 0; i < n; i++)
      {
        big = 0.0;
        for (j = 0; j < n; j++)
          if ((temp = Math.Abs(a[i][j])) > big) big = temp;
        if (big == 0.0)
          throw new Exception("Singular matrix in routine ludcmp!!!");
        vv[i] = 1.0 / big;
      }

      for (j = 0; j < n; j++)
      {
        for (i = 0; i < j; i++)
        {
          for (k = 0; k < i; k++)
            a[i][j] -= a[i][k] * a[k][j];
        }
        big = 0.0;
        for (i = j; i < n; i++)
        {
          for (k = 0; k < j; k++)
            a[i][j] -= a[i][k] * a[k][j];
          if ((dum = vv[i] * Math.Abs(a[i][j])) >= big)
          {
            big = dum;
            imax = i;
          }
        }
        if (j != imax)
        {
          for (k = 0; k < n; k++)
          {
            dum = a[imax][k];
            a[imax][k] = a[j][k];
            a[j][k] = dum;
          }
          d = -d;
          vv[imax] = vv[j];
        }
        indx[j] = imax;
        if (a[j][j] == 0.0)
          a[j][j] = 1.0e-20;
        if (j != n - 1)
        {
          dum = 1.0 / (a[j][j]);
          for (i = j + 1; i < n; i++)
            a[i][j] *= dum;
        }
      }
    }
    public static void lubksb(double[][] a, int n, int[] indx, double[] b)
    {
      int i, ii = -1, ip, j;
      double sum;

      for (i = 0; i < n; i++)
      {
        ip = indx[i];
        sum = b[ip];
        b[ip] = b[i];
        if (ii >= 0.0)
        {
          for (j = ii; j < i; j++)
            sum -= a[i][j] * b[j];
        }
        else if (sum != 0)
        {
          ii = i;
        }
        b[i] = sum;
      }
      for (i = n - 1; i > -1; i--)
      {
        sum = b[i];
        for (j = i + 1; j < n; j++) sum -= a[i][j] * b[j];
        b[i] = sum / a[i][i];
      }
    }

    public Tensor InverseMatrix()
    {
      if (order != 2)
      {
        throw new Exception("InverseMatrix: no second order Tensor!");
      }
      if (n_lines != n_columns)
      {
        throw new Exception("InverseMatrix: non-square Tensor!");
      }

      int i, j, n = n_lines;
      double[][] A, B;
      Tensor inv = new Tensor(n, n);

      A = new double[n][];
      B = new double[n][];

      for (i = 0; i < n; i++)
      {
        A[i] = new double[n];
        B[i] = new double[n];
        for (j = 0; j < n; j++) A[i][j] = this.value(i, j);
      }

      int[] indx;
      double d;
      double[] col;

      col = new double[n];
      indx = new int[n];

      ludcmp(A, n, indx, out d);
      for (j = 0; j < n; j++)
      {
        for (i = 0; i < n; i++)
          col[i] = 0.0;
        col[j] = 1.0;
        lubksb(A, n, indx, col);
        for (i = 0; i < n; i++)
          B[i][j] = col[i];
      }

      for( i=0; i< n; i++ )
        for( j=0; j<n; j++ )
          inv[ i, j ] = B[i][j];

      return (inv);
    }
    public static void inverse(Tensor oa)
    {

      if (oa.which_order != 2)
      {
        throw new Exception("inverse: no second order Tensor!");
      }
      if (oa.how_many_lines != oa.how_many_columns)
      {
        throw new Exception("inverse: non-square Tensor!");
      }

      int i, j, n = oa.how_many_lines;
      double[][] A, B;

      A = new double[n][];
      B = new double[n][];

      for (i = 0; i < n; i++)
      {
        A[i] = new double[n];
        B[i] = new double[n];
        for (j = 0; j < n; j++) A[i][j] = oa.value(i, j);
      }

      int[] indx;
      double d;
      double[] col;

      col = new double[n];
      indx = new int[n];

      ludcmp(A, n, indx, out d);
      for (j = 0; j < n; j++)
      {
        for (i = 0; i < n; i++)
          col[i] = 0.0;
        col[j] = 1.0;
        lubksb(A, n, indx, col);
        for (i = 0; i < n; i++)
          B[i][j] = col[i];
      }

      //for( i=0; i< n; i++ ){
      //  for( j=0; j<n; j++ )
      //    oa[ i, j ] = B[i][j];
    }
    public static void converse_C(Tensor o4, Tensor o2)
    {

      if (o4.which_order != 4 || o2.which_order != 2)
      {
        throw new Exception("converse_C: invalid Tensor order!");
      }
      if (o4.how_many_lines != 3 || o4.how_many_columns != 3 || o4.how_many_lines2 != 3 || o4.how_many_columns2 != 3 || o2.how_many_lines != 6 || o2.how_many_columns != 6)
      {
        throw new Exception("converse_C: invalid Tensor size!");
      }
      int i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;

      for (i = 0; i < 3; i++)
      {
        for (j = 0; j < 3; j++)
        {
          for (k = 0; k < 3; k++)
          {
            for (l = 0; l < 3; l++)
            {
              if (i == 0 && j == 0) m = 0;
              if (k == 0 && l == 0) n = 0;
              if (i == 1 && j == 1) m = 1;
              if (k == 1 && l == 1) n = 1;
              if (i == 2 && j == 2) m = 2;
              if (k == 2 && l == 2) n = 2;
              if (i == 0 && j == 1) m = 5;
              if (k == 0 && l == 1) n = 5;
              if (i == 1 && j == 2) m = 3;
              if (k == 1 && l == 2) n = 3;
              if (i == 0 && j == 2) m = 4;
              if (k == 0 && l == 2) n = 4;
              if (j == 0 && i == 1) m = 5;
              if (l == 0 && k == 1) n = 5;
              if (j == 1 && i == 2) m = 3;
              if (l == 1 && k == 2) n = 3;
              if (j == 0 && i == 2) m = 4;
              if (l == 0 && k == 2) n = 4;

              o2[m, n] = o4[i, j, k, l];
            }
          }
        }
      }
    }
    public static void converse_T(Tensor o4, Tensor o2)
    {
      if (o4.which_order != 4 || o2.which_order != 2)
      {
        throw new Exception("converse_T: invalid Tensor order!");
      }
      if (o4.how_many_lines != 3 || o4.how_many_columns != 3 || o4.how_many_lines2 != 3 || o4.how_many_columns2 != 3 || o2.how_many_lines != 6 || o2.how_many_columns != 6)
      {
        throw new Exception("converse_T: invalid Tensor size!");
      }

      int i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;

      for (i = 0; i < 3; i++)
      {
        for (j = 0; j < 3; j++)
        {
          for (k = 0; k < 3; k++)
          {
            for (l = 0; l < 3; l++)
            {
              if (i == 0 && j == 0) m = 0;
              if (k == 0 && l == 0) n = 0;
              if (i == 1 && j == 1) m = 1;
              if (k == 1 && l == 1) n = 1;
              if (i == 2 && j == 2) m = 2;
              if (k == 2 && l == 2) n = 2;
              if (i == 0 && j == 1) m = 5;
              if (k == 0 && l == 1) n = 5;
              if (i == 1 && j == 2) m = 3;
              if (k == 1 && l == 2) n = 3;
              if (i == 0 && j == 2) m = 4;
              if (k == 0 && l == 2) n = 4;
              if (j == 0 && i == 1) m = 5;
              if (l == 0 && k == 1) n = 5;
              if (j == 1 && i == 2) m = 3;
              if (l == 1 && k == 2) n = 3;
              if (j == 0 && i == 2) m = 4;
              if (l == 0 && k == 2) n = 4;

              if (i == j && k == l) o2[m, n] = o4[i, j, k, l];
              if (i == j && k != l) o2[m, n] = o4[i, j, k, l];
              if (i != j && k == l) o2[m, n] = 2.0 * o4[i, j, k, l];
              if (i != j && k != l) o2[m, n] = 2.0 * o4[i, j, k, l];
            }
          }
        }
      }
    }
    public static void back_converse_C(Tensor o2, Tensor o4)
    {

      if (o4.which_order != 4 || o2.which_order != 2)
      {
        throw new Exception("back_converse_C: invalid Tensor order!");
      }
      if (o4.how_many_lines != 3 || o4.how_many_columns != 3 || o4.how_many_lines2 != 3 || o4.how_many_columns2 != 3 || o2.how_many_lines != 6 || o2.how_many_columns != 6)
      {
        throw new Exception("back_converse_C: invalid Tensor size!");
      }

      int i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;

      for (m = 0; m < 6; m++)
      {
        for (n = 0; n < 6; n++)
        {

          if (m == 0) i = j = 0;
          if (n == 0) l = k = 0;
          if (m == 1) i = j = 1;
          if (n == 1) l = k = 1;
          if (m == 2) i = j = 2;
          if (n == 2) l = k = 2;

          if (m == 3) { i = 1; j = 2; }
          if (n == 3) { k = 1; l = 2; }
          if (m == 4) { i = 0; j = 2; }
          if (n == 4) { k = 0; l = 2; }
          if (m == 5) { i = 0; j = 1; }
          if (n == 5) { k = 0; l = 1; }

          o4[i, j, k, l] = o2[m, n];
          o4[i, j, l, k] = o2[m, n];
          o4[j, i, k, l] = o2[m, n];
          o4[j, i, l, k] = o2[m, n];

        }
      }
    }
    public static void back_converse_T(Tensor o2, Tensor o4)
    {

      if (o4.which_order != 4 || o2.which_order != 2)
      {
        throw new Exception("back_converse_T: invalid Tensor order!");
      }
      if (o4.how_many_lines != 3 || o4.how_many_columns != 3 || o4.how_many_lines2 != 3 || o4.how_many_columns2 != 3 || o2.how_many_lines != 6 || o2.how_many_columns != 6)
      {
        throw new Exception("back_converse_T: invalid Tensor size!");
      }

      int i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;

      for (m = 0; m < 6; m++)
      {
        for (n = 0; n < 6; n++)
        {
          if (m == 0) i = j = 0;
          if (n == 0) l = k = 0;
          if (m == 1) i = j = 1;
          if (n == 1) l = k = 1;
          if (m == 2) i = j = 2;
          if (n == 2) l = k = 2;

          if (m == 3) { i = 1; j = 2; }
          if (n == 3) { k = 1; l = 2; }
          if (m == 4) { i = 0; j = 2; }
          if (n == 4) { k = 0; l = 2; }
          if (m == 5) { i = 0; j = 1; }
          if (n == 5) { k = 0; l = 1; }

          if (i == j && k == l)
          {
            o4[i, j, k, l] = o2[m, n];
            o4[i, j, l, k] = o2[m, n];
            o4[j, i, k, l] = o2[m, n];
            o4[j, i, l, k] = o2[m, n];
          }
          if (i == j && k != l)
          {
            o4[i, j, k, l] = o2[m, n];
            o4[i, j, l, k] = o2[m, n];
            o4[j, i, k, l] = o2[m, n];
            o4[j, i, l, k] = o2[m, n];
          }
          if (i != j && k == l)
          {
            o4[i, j, k, l] = 0.5 * o2[m, n];
            o4[i, j, l, k] = 0.5 * o2[m, n];
            o4[j, i, k, l] = 0.5 * o2[m, n];
            o4[j, i, l, k] = 0.5 * o2[m, n];
          }
          if (i != j && k != l)
          {
            o4[i, j, k, l] = 0.5 * o2[m, n];
            o4[i, j, l, k] = 0.5 * o2[m, n];
            o4[j, i, k, l] = 0.5 * o2[m, n];
            o4[j, i, l, k] = 0.5 * o2[m, n];
          }
        }
      }
    }

    public static int delta(int o, int p)
    {
      if (o == p)
        return (1);
      else return 0;
    }

    public static Tensor StiffnessTensor(double elastic_modulus, double nu)    // isotropic
    {
      Tensor DEl = new Tensor(3, 3, 3, 3);
      double lambda, G;
      int i, j, k, l;

      G = elastic_modulus / (2 * (1 + nu));
      lambda = 2 * G * nu / (1 - 2 * nu);

      for (i = 0; i < 3; i++)
        for (j = 0; j < 3; j++)
          for (k = 0; k < 3; k++)
            for (l = 0; l < 3; l++)
              DEl[i, j, k, l] = lambda * delta(i, j) * delta(k, l) +
                                G * delta(i, k) * delta(j, l) +
                                G * delta(i, l) * delta(j, k);

      return (DEl);
    }
    public static Tensor StiffnessMatrix(double elastic_modulus, double nu)    // isotropic
    {
      Tensor DEl = new Tensor(6, 6);

      double lambda;

      lambda = elastic_modulus / ((1 + nu) * (1 - 2 * nu));

      DEl[0, 0] = DEl[1, 1] = DEl[2, 2] = lambda * (1 - nu);
      DEl[0, 1] = DEl[1, 0] = DEl[0, 2] = DEl[2, 0] = DEl[1, 2] = DEl[2, 1] = nu * lambda;
      DEl[3, 3] = DEl[4, 4] = DEl[5, 5] = lambda * (1 - 2 * nu) / 2.0;

      return (DEl);
    }
    public static Tensor ComplianceTensor(double elastic_modulus, double nu)    // isotropic
    {
      Tensor CEl = new Tensor(3, 3, 3, 3);
      int i, j, k, l;

      for (i = 0; i < 3; i++)
        for (j = 0; j < 3; j++)
          for (k = 0; k < 3; k++)
            for (l = 0; l < 3; l++)
              CEl[i, j, k, l] = (1 + nu) / elastic_modulus * (0.5*(delta(i, k) * delta(j, l)+delta(i, l) * delta(j, k)) - nu / (1 + nu) * delta(i, j) * delta(k, l));

      return (CEl);
    }
    public static Tensor ComplianceMatrix(double elastic_modulus, double nu)    // isotropic
    {
      Tensor CEl = new Tensor(6, 6);

      CEl[0, 0] = CEl[1, 1] = CEl[2, 2] = 1 / elastic_modulus;
      CEl[0, 1] = CEl[1, 0] = CEl[0, 2] = CEl[2, 0] = CEl[1, 2] = CEl[2, 1] = -nu / elastic_modulus;
      CEl[3, 3] = CEl[4, 4] = CEl[5, 5] = 2 * (1 + nu) / elastic_modulus;
     
      return (CEl);
    }
    
    public static Tensor StiffnessMatrix(double E11, double E22, double E33, double nu12, double nu13,
                                         double nu23, double G23, double G31, double G12)     // orthotropic
    {
      //DLE BIBLE(NUMERICKE METODY MECHANIKY I) STR. 18
      Tensor D = new Tensor(6,6);
      double lambda;
      double nu21, nu31, nu32;

      nu21 = nu12 * E11 / E22;
      nu31 = nu13 * E11 / E33;
      nu32 = nu23 * E22 / E33;

      lambda = 1 - (nu12 * nu21 + nu13 * nu31 + nu23 * nu32) - (nu12 * nu23 * nu31 + nu21 * nu32 * nu13);

      D[0, 0] = E11 * (1.0 - nu32 * nu23) / lambda;
      D[0, 1] = D[1, 0] = E11 * (nu12 + nu13 * nu32) / lambda;
      D[0, 2] = D[2, 0] = E11 * (nu13 + nu12 * nu23) / lambda;

      D[1, 1] = E22 * (1.0 - nu31 * nu13) / lambda;
      D[1, 2] = D[2, 1] = E22 * (nu23 + nu21 * nu13) / lambda;
      D[2, 2] = E33 * (1.0 - nu12 * nu21) / lambda;

      D[3, 3] = G23;
      D[4, 4] = G31;
      D[5, 5] = G12;

      return D;
    }
    public static Tensor ComplianceMatrix(double E11, double E22, double E33, double nu12, double nu13,
                                          double nu23, double G23, double G31, double G12)     // orthotropic
    {
      //DLE BIBLE(NUMERICKE METODY MECHANIKY I) STR. 18
      Tensor C = new Tensor(6, 6);

      C[0, 0] = 1 / E11;
      C[0, 1] = C[1, 0] = -nu12 / E22;
      C[0, 2] = C[2, 0] = -nu13 / E33;
      C[1, 1] = 1 / E22;
      C[1, 2] = C[2, 1] = -nu23 / E33;
      C[2, 2] = 1 / E33;
      C[3, 3] = 1 / G23;
      C[4, 4] = 1 / G31;
      C[5, 5] = 1 / G12;

      return C;
    }


    public static double EinsteinSumIJxIJ(Tensor oleft, Tensor oright)
    {
      int i, j;
      double dummy = 0;

      for (i = 0; i < 3; i++)
        for (j = 0; j < 3; j++)
          dummy += oleft[i, j] * oright[i, j];

      return dummy;
    }

    public void Print(string s, ILog log, bool print_tensor_size)
    {
      log.WriteLine(s);

      switch (order)
      {
        case 1:
          if (print_tensor_size)
          {
            log.WriteLine("order " + order.ToString() + ", lines" + n_lines.ToString());
          }
          for (int i = 0; i < n_lines; i++)
          {
            log.Write(value(i).ToString("E03") + "\t");
          }
          log.WriteLine();
          break;

        case 2:
          if (print_tensor_size)
          {
            log.WriteLine("order " + order.ToString() + ", lines" + n_lines.ToString() + ", columns" + n_columns.ToString());
          }
          for (int i = 0; i < n_lines; i++)
          {
            for (int j = 0; j < n_columns; j++)
            {
              log.Write(value(i, j).ToString("E03") + "\t");
            }
            log.WriteLine();
          }
          log.WriteLine();
          break;

        case 3:
          if (print_tensor_size)
          {
            log.WriteLine("order " + order.ToString() + ", lines" + n_lines.ToString() + ", columns" + n_columns.ToString() +
                          ", lines^2" + n_lines2.ToString());
          }
          for (int i = 0; i < n_lines; i++)
          {
            for (int j = 0; j < n_columns; j++)
            {
              for (int k = 0; k < n_lines2; k++)
              {
                log.Write(value(i, j, k).ToString("E03") + "\t");
              }
              log.WriteLine();
            }
            log.WriteLine();
          }
          log.WriteLine();
          break;

        case 4:
          if (print_tensor_size)
          {
            log.WriteLine("order " + order.ToString() + ", lines" + n_lines.ToString() + ", columns" + n_columns.ToString() +
                          ", lines^2" + n_lines2.ToString() + ", columns^2" + n_columns2.ToString());
          }
          for (int i = 0; i < n_lines; i++)
          {
            for (int j = 0; j < n_columns; j++)
            {
              for (int k = 0; k < n_lines2; k++)
              {
                for (int l = 0; l < n_columns2; l++)
                {
                  log.Write(value(i, j, k, l).ToString("E03") + "\t");
                }
                log.WriteLine();
              }
              log.WriteLine();
            }
            log.WriteLine();
          }
          log.WriteLine();
          break;
        default:
          throw new Exception("Tensor: Print: invalid Tensor order!\n");
      }
    }
    public void Clear()
    {
      switch (order)
      {
        case 1:
          for (int i = 0; i < n_lines; i++)
          {
            x[i] = 0.0;
          }
          break;

        case 2:
          for (int i = 0; i < n_lines; i++)
          {
            for (int j = 0; j < n_columns; j++)
            {
              x[i * n_columns + j] = 0.0;
            }
          }
          break;

        case 3:
          for (int i = 0; i < n_lines; i++)
          {
            for (int j = 0; j < n_columns; j++)
            {
              for (int k = 0; k < n_lines2; k++)
              {
                x[i * n_columns * n_lines2 + j * n_lines2 + k] = 0.0;
              }
            }
          }
          break;

        case 4:
          for (int i = 0; i < n_lines; i++)
          {
            for (int j = 0; j < n_columns; j++)
            {
              for (int k = 0; k < n_lines2; k++)
              {
                for (int l = 0; l < n_columns2; l++)
                {
                  x[i * n_columns * n_lines2 * n_columns2 + j * n_lines2 * n_columns2 + k * n_columns2 + l] = 0.0;
                }
              }
            }
          }
          break;

        default:
          throw new Exception("Tensor: Clear: invalid Tensors order!\n");

      }
    }
    public void Identity()
    {
      if (order != 2)
      {
        throw new Exception("Identity: no second order Tensor!\n");
      }
      if (n_lines != n_columns)
      {
        throw new Exception("Identity: non-square Tensor!\n");
      }

      for (int i = 0; i < n_lines; i++)
      {
        for (int j = 0; j < n_lines; j++)
        {
          if (i == j)
          {
            x[i * n_columns + j] = 1.0;
          }
          else
          {
            x[i * n_columns + j] = 0.0;
          }
        }
      }
    }
    public static Tensor GetIdentityTensor(int size)
    {
      Tensor I = new Tensor(size, size);

      I.Identity();

      return (I);
    }
    public void SetToValue(double value)
    {
      int i;

      switch (order)
      {
        case 1:
          for (i = 0; i < n_lines; i++)
          {
            x[i] = value;
          }
          break;

        case 2:
          for (i = 0; i < n_lines * n_columns; i++)
          {
            x[i] = value;
          }
          break;

        case 3:
          for (i = 0; i < n_lines * n_columns * n_lines2; i++)
          {
            x[i] = value;
          }
          break;

        case 4:
          for (i = 0; i < n_lines * n_columns * n_lines2 * n_columns2; i++)
          {
            x[i] = value;
          }
          break;

        default:
          {
            throw new Exception("Tensor: SetToValue(double value): wrong order!\n ");
          }
      }
    }
    public Tensor Transposition()			//for 2nd order tensor
    {
      Tensor oa = new Tensor(1, n_lines);
      Tensor ob = new Tensor(n_columns, n_lines);

      switch (order)
      {
        case 1:
          for (int i = 0; i < n_lines; i++)
            oa.x[i] = x[i];
          return oa;

        case 2:
          for (int i = 0; i < n_lines; i++)
            for (int j = 0; j < n_columns; j++)
              ob.x[j * n_lines + i] = x[i * n_columns + j];
          return ob;

        default:
          throw new Exception("Tensor: Transposition: invalid Tensor order!\n");
      }
    }

    public double InvariantI1()
    {
      if (n_lines != n_columns || n_lines != 3)
      {
        throw new Exception("Tensor: InvariantI1: invalid Tensor size!");
      }
      return (x[0] + x[4] + x[8]);
    }
    public Tensor Deviator()
    {
      if (n_lines != n_columns || n_lines != 3)
      {
        throw new Exception("Tensor: Deviator: invalid Tensor size!");
      }

      double dummy;
      Tensor deviator = new Tensor(this);

      dummy = (x[0] + x[4] + x[8]) / 3.0;
      for (int i = 0; i < 3; i++)
        deviator[i, i] -= dummy;

      return (deviator);
    }
    public double InvariantJ()
    {
      if (n_lines != n_columns || n_lines != 3)
      {
        throw new Exception("Tensor: InvariantJ: invalid Tensor size!");
      }

      double J, dummy;

      dummy = (x[0] + x[4] + x[8]) / 3.0;

      J = Math.Sqrt(0.5 * ((x[0] - dummy) * (x[0] - dummy) + x[1] * x[1] + x[2] * x[2] + x[3] * x[3] + (x[4] - dummy) * (x[4] - dummy) +
                    x[5] * x[5] + x[6] * x[6] + x[7] * x[7] + (x[8] - dummy) * (x[8] - dummy)));

      return (J);
    }
    public double InvariantJ2()
    {
      if (n_lines != n_columns || n_lines != 3)
      {
        throw new Exception("Tensor: InvariantJ2: invalid Tensor size!");
      }

      double J2, dummy;

      dummy = (x[0] + x[4] + x[8]) / 3.0;

      J2 = 0.5 * ((x[0] - dummy) * (x[0] - dummy) + x[1] * x[1] + x[2] * x[2] + x[3] * x[3] + (x[4] - dummy) * (x[4] - dummy) +
                x[5] * x[5] + x[6] * x[6] + x[7] * x[7] + (x[8] - dummy) * (x[8] - dummy));

      return (J2);
    }
    public double InvariantJ3()
    {
      if (n_lines != n_columns || n_lines != 3)
      {
        throw new Exception("Tensor: InvariantJ3: invalid Tensor size!");
      }

      double dummy;
      Tensor oa = new Tensor(this);

      dummy = (x[0] + x[4] + x[8]) / 3.0;
      oa.x[0] -= dummy; oa.x[4] -= dummy; oa.x[8] -= dummy;

      dummy = 0.0;
      for (int i = 0; i < 3; i++)
        for (int j = 0; j < 3; j++)
          for (int k = 0; k < 3; k++)
            dummy += oa.x[i * 3 + j] * oa.x[j * 3 + k] * oa.x[k * 3 + i];

      return (dummy / 3);
    }
    public double EquivalentDeviatoricStrain()		//return eqv. strain of strain tensor
    {
      if (n_lines != n_columns || n_lines != 3)
      {
        throw new Exception("Tensor: EquivalentDeviatoricStrain: invalid Tensor size! \n");
      }

      double dummy, EqvDStrain;

      dummy = (x[0] + x[4] + x[8]) / 3;

      EqvDStrain = Math.Sqrt(2 * ((x[0] - dummy) * (x[0] - dummy) + x[1] * x[1] + x[2] * x[2] + x[3] * x[3] + (x[4] - dummy) * (x[4] - dummy) +
                     x[5] * x[5] + x[6] * x[6] + x[7] * x[7] + (x[8] - dummy) * (x[8] - dummy)));

      return EqvDStrain;
    }
    public double MeanStress()
    {
      if (n_lines != n_columns || n_lines != 3)
      {
        throw new Exception("Tensor: MeanStress: invalid Tensor size!");
      }
      return ((x[0] + x[4] + x[8]) / 3);
    }

    public void Jacobi(ref Tensor eigvec, ref Tensor eigval, long n_iter, out long perform_iter, double accuracy, bool sort)	//eigenvalues and eigenvectors
    {
      /**********************************************************************************
       * @param eigvec - array storing eigenvectors																			*	
       * @param eigval - array storing eigenvalues																			*
       * @param n_iter - maximum number of iterations																		*
       * @param perform_iter - number of performed iterations														*
       * @param accuracy - maximum acceptable absolute value of offdiagonal element		  *
       * @param sort - for sorting put 1 else it doesn't sort values into decreasing v. *
       **********************************************************************************/


      if (n_lines != n_columns || eigvec.how_many_columns != eigvec.how_many_lines || n_lines != eigvec.how_many_lines ||
        order != 2 || eigvec.which_order != 2 || eigval.which_order != 1 || eigval.how_many_lines != n_lines)
      {
        throw new Exception("Tensor: Jacobi: invalid enteries!");
      }

      long i, j, k, l, ii, jj, en, nn, n = n_lines;
      double c, s, q, r, t, ai, aj;
      Tensor rot = new Tensor(this);							//rotated matrix

      en = (n * n - n) / 2;

      //  initial values
      eigvec.Identity();

      //  main iteration loop
      for (k = 0; k < n_iter; k++)
      {
        nn = 0;
        for (i = 0; i < n; i++)
        {
          for (j = i + 1; j < n; j++)
          {
            if (Math.Abs(rot.x[i * n + j]) < accuracy)
            {
              nn++; continue;
            }
            else
            {
              q = (rot.x[j * n + j] - rot.x[i * n + i]) / 2.0 / rot.x[i * n + j];
              r = Math.Sqrt(1.0 + q * q);
              if (q >= 0.0) t = -q + r;
              else t = -q - r;
              r = Math.Sqrt(1.0 + t * t);
              c = 1.0 / r;
              s = t * c;

              //  A.J
              ii = i; jj = j;
              for (l = 0; l < n; l++)
              {
                ai = rot.x[ii];
                aj = rot.x[jj];
                rot.x[ii] = ai * c - aj * s;
                rot.x[jj] = ai * s + aj * c;
                ii += n; jj += n;
              }

              //  J.A.J
              ii = i * n; jj = j * n;
              for (l = 0; l < n; l++)
              {
                ai = rot.x[ii];
                aj = rot.x[jj];
                rot.x[ii] = ai * c - aj * s;
                rot.x[jj] = ai * s + aj * c;
                ii++; jj++;
              }

              //  Q=Q.J
              ii = i; jj = j;
              for (l = 0; l < n; l++)
              {
                ai = eigvec.x[ii];
                aj = eigvec.x[jj];
                eigvec.x[ii] = ai * c - aj * s;
                eigvec.x[jj] = ai * s + aj * c;
                ii += n; jj += n;
              }
            }
          }
        }
        if (nn == en)
        {
          break;
        }
      }

      //  number of performed iterations
      perform_iter = k;

      for (i = 0; i < n; i++)
      {
        eigval.x[i] = rot.x[i * n + i];
      }


      // this sorts the eigenvalues into the descending order and rearranges matrix of eigenvectors
      if (sort)
      {
        for (i = 0; i < n - 1; i++)
        {
          k = i;
          q = eigval.x[i];
          for (j = i + 1; j < n; j++)
            if (eigval.x[j] >= q)
            {
              k = j;
              q = eigval.x[j];
            }

          if (k != i)
          {
            eigval.x[k] = eigval.x[i];
            eigval.x[i] = q;
            for (j = 0; j < n; j++)
            {
              q = eigvec.x[j * n_columns + i];
              eigvec.x[j * n_columns + i] = eigvec.x[j * n_columns + k];
              eigvec.x[j * n_columns + k] = q;
            }
          }
        }
      }
    }
    public double[] EigenValues()
    {
      if (n_lines != n_columns || n_lines != 3)
      {
        throw new Exception("EigenValues: invalid Tensor size!");
      }
      /*	A P Q		*				ax^3+bx^2+cx/d=0, where a=-1.
      *		P B R		*
      *		Q R C		*/

      double m, p, q, D, c, s;
      double phi = 0, dummy;
      double[] y = new double[3];

      m = (x[0] + x[4] + x[8]) / 3;
      q = 0.5 * ((x[0] - m) * (x[4] - m) * (x[8] - m) + x[3] * x[7] * x[2] + x[6] * x[1] * x[5] -
                x[2] * (x[4] - m) * x[6] - x[5] * x[7] * (x[0] - m) - (x[8] - m) * x[1] * x[3]);
      p = ((x[0] - m) * (x[0] - m) + (x[4] - m) * (x[4] - m) + (x[8] - m) * (x[8] - m) + 2 * x[1] * x[1] + 2 * x[2] * x[2] + 2 * x[5] * x[5]) / 6;

      D = p * p * p - q * q;
      if (p == q && p == 0.0)
      {
        y[0] = y[1] = y[2] = m;
      }
      else if (D >= 0.0)
      {
        phi = (Math.Atan(Math.Sqrt(D) / q)) / 3;

        p = Math.Sqrt(p);			//abych to pak nemusel pocitat tolikrat
        c = Math.Cos(phi);
        s = Math.Sin(phi);

        if (Math.Abs(phi) > Math.PI)
        {
          throw new Exception("EigenValues: invalid solution phi - too high!");
        }
        else if (q >= 0.0)
        {
          y[0] = m + 2 * p * c;
          y[1] = m - p * (c + Math.Sqrt(3) * s);
          y[2] = m - p * (c - Math.Sqrt(3) * s);
        }
        else
        {
          y[0] = m - 2 * p * c;
          y[1] = m + p * (c + Math.Sqrt(3) * s);
          y[2] = m + p * (c - Math.Sqrt(3) * s);
        }
      }
      else if (D < 0.0)
      {
        if (D < -Constants.ZERO)
        {
          throw new Exception("EigenValues: invalid solution (D<0)-high relative error!");
        }

        phi = 0.0;

        p = Math.Sqrt(p);			//abych to pak nemusel pocitat tolikrat

        if (q >= 0.0)
        {
          y[0] = m + 2 * p;
          y[1] = y[2] = m - p;
        }
        else
        {
          y[0] = m - 2 * p;
          y[1] = y[2] = m + p;
        }
      }

      for (int i = 2; i > 0; i--)			//arrangement of the values
        for (int j = 0; j < i; j++)
          if (y[i] > y[j])
          {
            dummy = y[j];
            y[j] = y[i];
            y[i] = dummy;
          }

      return y;
    }
    public Tensor AxisControl()
    {
      if (n_lines != n_columns || n_lines != 3)
      {
        throw new Exception("AxisControl: invalid Tensor size!");
      }

      double[] dummy = new double[3];
      Tensor a = new Tensor(this);


      dummy[0] = (x[3] * x[7] - x[4] * x[6]);
      dummy[1] = (x[6] * x[1] - x[7] * x[0]);
      dummy[2] = (x[0] * x[4] - x[1] * x[3]);


      if (Math.Abs(dummy[0] + x[2]) < Constants.ZERO * 1e5 && Math.Abs(dummy[1] + x[5]) < Constants.ZERO * 1e5 && Math.Abs(dummy[2] + x[8]) < Constants.ZERO * 1e5)
      {
        a.x[2] *= -1;
        a.x[5] *= -1;
        a.x[8] *= -1;
      }
      else if (!(Math.Abs(dummy[0] - x[2]) < Constants.ZERO * 1e5 && Math.Abs(dummy[1] - x[5]) < Constants.ZERO * 1e5 && Math.Abs(dummy[2] - x[8]) < Constants.ZERO * 1e5))
      {
        throw new Exception("axisControl: Tensor isn't orthogonal!");
      }

      return (a);
    }

    public static Tensor TransformationEulerAngles_zyz(double phi, double theta, double beta)  //angles from global to local
    {
      Tensor T = new Tensor(3, 3);

      T[0, 0] = Math.Cos(phi) * Math.Cos(theta) * Math.Cos(beta) - Math.Sin(phi) * Math.Sin(beta);
      T[1, 0] = -Math.Cos(phi) * Math.Cos(theta) * Math.Sin(beta) - Math.Sin(phi) * Math.Cos(beta);
      T[2, 0] = Math.Cos(phi) * Math.Sin(theta);

      T[0, 1] = Math.Sin(phi) * Math.Cos(theta) * Math.Cos(beta) + Math.Cos(phi) * Math.Sin(beta);
      T[1, 1] = -Math.Sin(phi) * Math.Cos(theta) * Math.Sin(beta) + Math.Cos(phi) * Math.Cos(beta);
      T[2, 1] = Math.Sin(phi) * Math.Sin(theta);

      T[0, 2] = -Math.Sin(theta) * Math.Cos(beta);
      T[1, 2] = Math.Sin(theta) * Math.Sin(beta);
      T[2, 2] = Math.Cos(theta);

      return (T);
    }
    public Tensor TransformationEulerAngles_zyz()   //order phi,theta,beta
    {
      if(order!=1 || n_lines!=3)
      {
        throw new Exception("Tensor: TransformationEulerAngles_zyz: invalid tensor of angles!");
      }

      return (TransformationEulerAngles_zyz(this.value(0), this.value(1), this.value(2)));
    }

    public Tensor TransformationForStress()  //for Voight notation
    {
      if (order != 2 || n_lines != 3 || n_columns != 3)
      {
        throw new Exception("Tensor: TransformationForStress: invalid tensor of angles!");
      }

      Tensor T = new Tensor(6, 6);

      T[0, 0] = this.value(0, 0) * this.value(0, 0);
      T[0, 1] = this.value(0, 1) * this.value(0, 1);
      T[0, 2] = this.value(0, 2) * this.value(0, 2);
      T[0, 3] = 2 * this.value(0, 1) * this.value(0, 2);
      T[0, 4] = 2 * this.value(0, 0) * this.value(0, 2);
      T[0, 5] = 2 * this.value(0, 0) * this.value(0, 1);

      T[1, 0] = this.value(1, 0) * this.value(1, 0);
      T[1, 1] = this.value(1, 1) * this.value(1, 1);
      T[1, 2] = this.value(1, 2) * this.value(1, 2);
      T[1, 3] = 2 * this.value(1, 1) * this.value(1, 2);
      T[1, 4] = 2 * this.value(1, 0) * this.value(1, 2);
      T[1, 5] = 2 * this.value(1, 0) * this.value(1, 1);

      T[2, 0] = this.value(2, 0) * this.value(2, 0);
      T[2, 1] = this.value(2, 1) * this.value(2, 1);
      T[2, 2] = this.value(2, 2) * this.value(2, 2);
      T[2, 3] = 2 * this.value(2, 1) * this.value(2, 2);
      T[2, 4] = 2 * this.value(2, 0) * this.value(2, 2);
      T[2, 5] = 2 * this.value(2, 0) * this.value(2, 1);

      T[3, 0] = this.value(2, 0) * this.value(1, 0);
      T[3, 1] = this.value(2, 1) * this.value(1, 1);
      T[3, 2] = this.value(2, 2) * this.value(1, 2);
      T[3, 3] = this.value(2, 1) * this.value(1, 2) + this.value(2, 2) * this.value(1, 1);
      T[3, 4] = this.value(2, 2) * this.value(1, 0) + this.value(2, 0) * this.value(1, 2);
      T[3, 5] = this.value(2, 0) * this.value(1, 1) + this.value(2, 1) * this.value(1, 0);

      T[4, 0] = this.value(2, 0) * this.value(0, 0);
      T[4, 1] = this.value(2, 1) * this.value(0, 1);
      T[4, 2] = this.value(2, 2) * this.value(0, 2);
      T[4, 3] = this.value(2, 1) * this.value(0, 2) + this.value(2, 2) * this.value(0, 1);
      T[4, 4] = this.value(2, 2) * this.value(0, 0) + this.value(2, 0) * this.value(0, 2);
      T[4, 5] = this.value(2, 1) * this.value(0, 0) + this.value(2, 0) * this.value(0, 1);

      T[5, 0] = this.value(1, 0) * this.value(0, 0);
      T[5, 1] = this.value(1, 1) * this.value(0, 1);
      T[5, 2] = this.value(1, 2) * this.value(0, 2);
      T[5, 3] = this.value(1, 2) * this.value(0, 1) + this.value(1, 1) * this.value(0, 2);
      T[5, 4] = this.value(1, 2) * this.value(0, 0) + this.value(1, 0) * this.value(0, 2);
      T[5, 5] = this.value(1, 1) * this.value(0, 0) + this.value(1, 0) * this.value(0, 1);

      return T;
    }

    public Tensor TransformationForStressInverse()  //for Voight notation
    {
      Tensor T = new Tensor(this.TransformationForStrain().Transposition());
      return T;
    }

    public Tensor TransformationForStrain()  //for Voight notation
    {
      if (order != 2 || n_lines != 3 || n_columns != 3)
      {
        throw new Exception("Tensor: TransformationForStrain: invalid tensor of angles!");
      }

      Tensor T = new Tensor(6, 6);

      T[0, 0] = this.value(0, 0) * this.value(0, 0);
      T[0, 1] = this.value(0, 1) * this.value(0, 1);
      T[0, 2] = this.value(0, 2) * this.value(0, 2);
      T[0, 3] = this.value(0, 1) * this.value(0, 2);
      T[0, 4] = this.value(0, 0) * this.value(0, 2);
      T[0, 5] = this.value(0, 0) * this.value(0, 1);

      T[1, 0] = this.value(1, 0) * this.value(1, 0);
      T[1, 1] = this.value(1, 1) * this.value(1, 1);
      T[1, 2] = this.value(1, 2) * this.value(1, 2);
      T[1, 3] = this.value(1, 1) * this.value(1, 2);
      T[1, 4] = this.value(1, 0) * this.value(1, 2);
      T[1, 5] = this.value(1, 0) * this.value(1, 1);

      T[2, 0] = this.value(2, 0) * this.value(2, 0);
      T[2, 1] = this.value(2, 1) * this.value(2, 1);
      T[2, 2] = this.value(2, 2) * this.value(2, 2);
      T[2, 3] = this.value(2, 1) * this.value(2, 2);
      T[2, 4] = this.value(2, 0) * this.value(2, 2);
      T[2, 5] = this.value(2, 0) * this.value(2, 1);

      T[3, 0] = 2 * this.value(2, 0) * this.value(1, 0);
      T[3, 1] = 2 * this.value(2, 1) * this.value(1, 1);
      T[3, 2] = 2 * this.value(2, 2) * this.value(1, 2);
      T[3, 3] = this.value(2, 1) * this.value(1, 2) + this.value(2, 2) * this.value(1, 1);
      T[3, 4] = this.value(2, 2) * this.value(1, 0) + this.value(2, 0) * this.value(1, 2);
      T[3, 5] = this.value(2, 0) * this.value(1, 1) + this.value(2, 1) * this.value(1, 0);

      T[4, 0] = 2 * this.value(2, 0) * this.value(0, 0);
      T[4, 1] = 2 * this.value(2, 1) * this.value(0, 1);
      T[4, 2] = 2 * this.value(2, 2) * this.value(0, 2);
      T[4, 3] = this.value(2, 1) * this.value(0, 2) + this.value(2, 2) * this.value(0, 1);
      T[4, 4] = this.value(2, 2) * this.value(0, 0) + this.value(2, 0) * this.value(0, 2);
      T[4, 5] = this.value(2, 1) * this.value(0, 0) + this.value(2, 0) * this.value(0, 1);

      T[5, 0] = 2 * this.value(1, 0) * this.value(0, 0);
      T[5, 1] = 2 * this.value(1, 1) * this.value(0, 1);
      T[5, 2] = 2 * this.value(1, 2) * this.value(0, 2);
      T[5, 3] = this.value(1, 2) * this.value(0, 1) + this.value(1, 1) * this.value(0, 2);
      T[5, 4] = this.value(1, 2) * this.value(0, 0) + this.value(1, 0) * this.value(0, 2);
      T[5, 5] = this.value(1, 1) * this.value(0, 0) + this.value(1, 0) * this.value(0, 1);

      return T;
    }

    public Tensor TransformationForStrainInverse()  //for Voight notation
    {
      Tensor T = new Tensor(this.TransformationForStress().Transposition());
      return T;
    }

    public Tensor RotationOf4thOrderTensor(Tensor TransformationMatrix)  //for Voight notation
    {
      if (order != 4 || n_lines != 3 || n_columns != 3 || n_lines2 != 3 || n_columns2 != 3 ||
          TransformationMatrix.which_order != 2 || TransformationMatrix.how_many_lines != 3 ||
          TransformationMatrix.how_many_columns != 3)
      {
        throw new Exception("Tensor: TransformationOfStiffnessTensor: invalid tensor!");
      }

      Tensor T = new Tensor(3, 3, 3, 3);

      for (int i = 0; i < 3; i++)
        for (int j = 0; j < 3; j++)
          for (int k = 0; k < 3; k++)
            for (int l = 0; l < 3; l++)
              for (int i1 = 0; i1 < 3; i1++)
                for (int j1 = 0; j1 < 3; j1++)
                  for (int k1 = 0; k1 < 3; k1++)
                    for (int l1 = 0; l1 < 3; l1++)
                      T[i, j, k, l] += this[i1, j1, k1, l1] * TransformationMatrix[i, i1] * TransformationMatrix[j, j1] * 
                                       TransformationMatrix[k, k1] * TransformationMatrix[l, l1];
      
      return T;
    }

    public Tensor Conversion4thTo2ndOrderStiffness() //this is used to transform the 4th order stiffness tensor(3,3,3,3) to the stifness matrix(6,6)
    {
      if (order != 4 || n_lines != 3 || n_columns != 3 || n_lines2 != 3 || n_columns2 != 3)
      {
        throw new Exception("Tensor: Conversion4thTo2ndOrderStiffness(): invalid tensor size!");
      }

      Tensor dummy = new Tensor(6, 6);

      dummy[0, 0] = this[0, 0, 0, 0];
      dummy[0, 1] = this[0, 0, 1, 1];
      dummy[0, 2] = this[0, 0, 2, 2];
      dummy[0, 3] = 0.5 * (this[0, 0, 1, 2] + this[0, 0, 2, 1]);
      dummy[0, 4] = 0.5 * (this[0, 0, 0, 2] + this[0, 0, 2, 0]);
      dummy[0, 5] = 0.5 * (this[0, 0, 0, 1] + this[0, 0, 1, 0]);

      dummy[1, 0] = this[1, 1, 0, 0];
      dummy[1, 1] = this[1, 1, 1, 1];
      dummy[1, 2] = this[1, 1, 2, 2];
      dummy[1, 3] = 0.5 * (this[1, 1, 1, 2] + this[1, 1, 2, 1]);
      dummy[1, 4] = 0.5 * (this[1, 1, 0, 2] + this[1, 1, 2, 0]);
      dummy[1, 5] = 0.5 * (this[1, 1, 0, 1] + this[1, 1, 1, 0]);

      dummy[2, 0] = this[2, 2, 0, 0];
      dummy[2, 1] = this[2, 2, 1, 1];
      dummy[2, 2] = this[2, 2, 2, 2];
      dummy[2, 3] = 0.5 * (this[2, 2, 1, 2] + this[2, 2, 2, 1]);
      dummy[2, 4] = 0.5 * (this[2, 2, 0, 2] + this[2, 2, 2, 0]);
      dummy[2, 5] = 0.5 * (this[2, 2, 0, 1] + this[2, 2, 1, 0]);

      dummy[3, 0] = this[1, 2, 0, 0];
      dummy[3, 1] = this[1, 2, 1, 1];
      dummy[3, 2] = this[1, 2, 2, 2];
      dummy[3, 3] = 0.5 * (this[1, 2, 1, 2] + this[1, 2, 2, 1]);
      dummy[3, 4] = 0.5 * (this[1, 2, 0, 2] + this[1, 2, 2, 0]);
      dummy[3, 5] = 0.5 * (this[1, 2, 0, 1] + this[1, 2, 1, 0]);

      dummy[4, 0] = this[0, 2, 0, 0];
      dummy[4, 1] = this[0, 2, 1, 1];
      dummy[4, 2] = this[0, 2, 2, 2];
      dummy[4, 3] = 0.5 * (this[0, 2, 1, 2] + this[0, 2, 2, 1]);
      dummy[4, 4] = 0.5 * (this[0, 2, 0, 2] + this[0, 2, 2, 0]);
      dummy[4, 5] = 0.5 * (this[0, 2, 0, 1] + this[0, 2, 1, 0]);

      dummy[5, 0] = this[0, 1, 0, 0];
      dummy[5, 1] = this[0, 1, 1, 1];
      dummy[5, 2] = this[0, 1, 2, 2];
      dummy[5, 3] = 0.5 * (this[0, 1, 1, 2] + this[0, 1, 2, 1]);
      dummy[5, 4] = 0.5 * (this[0, 1, 0, 2] + this[0, 1, 2, 0]);
      dummy[5, 5] = 0.5 * (this[0, 1, 0, 1] + this[0, 1, 1, 0]);

      return (dummy);
    }
    public Tensor Conversion4thTo2ndOrderCompliance() //this is used to transform the 4th order compliance tensor(3,3,3,3) to the comliance matrix(6,6)
    {
      if (order != 4 || n_lines != 3 || n_columns != 3 || n_lines2 != 3 || n_columns2 != 3)
      {
        throw new Exception("Tensor: Conversion4thTo2ndOrderCompliance(): invalid tensor size!");
      }

      Tensor dummy = new Tensor(6, 6);

      dummy[0, 0] = this[0, 0, 0, 0];
      dummy[0, 1] = this[0, 0, 1, 1];
      dummy[0, 2] = this[0, 0, 2, 2];
      dummy[0, 3] = (this[0, 0, 1, 2] + this[0, 0, 2, 1]);
      dummy[0, 4] = (this[0, 0, 0, 2] + this[0, 0, 2, 0]);
      dummy[0, 5] = (this[0, 0, 0, 1] + this[0, 0, 1, 0]);

      dummy[1, 0] = this[1, 1, 0, 0];
      dummy[1, 1] = this[1, 1, 1, 1];
      dummy[1, 2] = this[1, 1, 2, 2];
      dummy[1, 3] = (this[1, 1, 1, 2] + this[1, 1, 2, 1]);
      dummy[1, 4] = (this[1, 1, 0, 2] + this[1, 1, 2, 0]);
      dummy[1, 5] = (this[1, 1, 0, 1] + this[1, 1, 1, 0]);

      dummy[2, 0] = this[2, 2, 0, 0];
      dummy[2, 1] = this[2, 2, 1, 1];
      dummy[2, 2] = this[2, 2, 2, 2];
      dummy[2, 3] = (this[2, 2, 1, 2] + this[2, 2, 2, 1]);
      dummy[2, 4] = (this[2, 2, 0, 2] + this[2, 2, 2, 0]);
      dummy[2, 5] = (this[2, 2, 0, 1] + this[2, 2, 1, 0]);

      dummy[3, 0] = this[1, 2, 0, 0];
      dummy[3, 1] = this[1, 2, 1, 1];
      dummy[3, 2] = this[1, 2, 2, 2];
      dummy[3, 3] = 2 * (this[1, 2, 1, 2] + this[1, 2, 2, 1]);
      dummy[3, 4] = 2 * (this[1, 2, 0, 2] + this[1, 2, 2, 0]);
      dummy[3, 5] = 2 * (this[1, 2, 0, 1] + this[1, 2, 1, 0]);

      dummy[4, 0] = this[0, 2, 0, 0];
      dummy[4, 1] = this[0, 2, 1, 1];
      dummy[4, 2] = this[0, 2, 2, 2];
      dummy[4, 3] = 2 * (this[0, 2, 1, 2] + this[0, 2, 2, 1]);
      dummy[4, 4] = 2 * (this[0, 2, 0, 2] + this[0, 2, 2, 0]);
      dummy[4, 5] = 2 * (this[0, 2, 0, 1] + this[0, 2, 1, 0]);

      dummy[5, 0] = this[0, 1, 0, 0];
      dummy[5, 1] = this[0, 1, 1, 1];
      dummy[5, 2] = this[0, 1, 2, 2];
      dummy[5, 3] = 2 * (this[0, 1, 1, 2] + this[0, 1, 2, 1]);
      dummy[5, 4] = 2 * (this[0, 1, 0, 2] + this[0, 1, 2, 0]);
      dummy[5, 5] = 2 * (this[0, 1, 0, 1] + this[0, 1, 1, 0]);

      return (dummy);
    }
    public Tensor Conversion4thTo2ndOrderEshelby() //this is used to transform the 4th order Eshelby tensor(3,3,3,3) to the Eshelby matrix(6,6)
    {
      if (order != 4 || n_lines != 3 || n_columns != 3 || n_lines2 != 3 || n_columns2 != 3)
      {
        throw new Exception("Tensor: Conversion4thTo2ndOrderStiffness(): invalid tensor size!");
      }

      Tensor dummy = new Tensor(6, 6);

      dummy[0, 0] = this[0, 0, 0, 0];
      dummy[0, 1] = this[0, 0, 1, 1];
      dummy[0, 2] = this[0, 0, 2, 2];
      dummy[0, 3] = 0.5 * (this[0, 0, 1, 2] + this[0, 0, 2, 1]);
      dummy[0, 4] = 0.5 * (this[0, 0, 0, 2] + this[0, 0, 2, 0]);
      dummy[0, 5] = 0.5 * (this[0, 0, 0, 1] + this[0, 0, 1, 0]);

      dummy[1, 0] = this[1, 1, 0, 0];
      dummy[1, 1] = this[1, 1, 1, 1];
      dummy[1, 2] = this[1, 1, 2, 2];
      dummy[1, 3] = 0.5 * (this[1, 1, 1, 2] + this[1, 1, 2, 1]);
      dummy[1, 4] = 0.5 * (this[1, 1, 0, 2] + this[1, 1, 2, 0]);
      dummy[1, 5] = 0.5 * (this[1, 1, 0, 1] + this[1, 1, 1, 0]);

      dummy[2, 0] = this[2, 2, 0, 0];
      dummy[2, 1] = this[2, 2, 1, 1];
      dummy[2, 2] = this[2, 2, 2, 2];
      dummy[2, 3] = 0.5 * (this[2, 2, 1, 2] + this[2, 2, 2, 1]);
      dummy[2, 4] = 0.5 * (this[2, 2, 0, 2] + this[2, 2, 2, 0]);
      dummy[2, 5] = 0.5 * (this[2, 2, 0, 1] + this[2, 2, 1, 0]);

      dummy[3, 0] = 2 * this[1, 2, 0, 0];
      dummy[3, 1] = 2 * this[1, 2, 1, 1];
      dummy[3, 2] = 2 * this[1, 2, 2, 2];
      dummy[3, 3] = (this[1, 2, 1, 2] + this[1, 2, 2, 1]);
      dummy[3, 4] = (this[1, 2, 0, 2] + this[1, 2, 2, 0]);
      dummy[3, 5] = (this[1, 2, 0, 1] + this[1, 2, 1, 0]);

      dummy[4, 0] = 2 * this[0, 2, 0, 0];
      dummy[4, 1] = 2 * this[0, 2, 1, 1];
      dummy[4, 2] = 2 * this[0, 2, 2, 2];
      dummy[4, 3] = (this[0, 2, 1, 2] + this[0, 2, 2, 1]);
      dummy[4, 4] = (this[0, 2, 0, 2] + this[0, 2, 2, 0]);
      dummy[4, 5] = (this[0, 2, 0, 1] + this[0, 2, 1, 0]);

      dummy[5, 0] = 2 * this[0, 1, 0, 0];
      dummy[5, 1] = 2 * this[0, 1, 1, 1];
      dummy[5, 2] = 2 * this[0, 1, 2, 2];
      dummy[5, 3] = (this[0, 1, 1, 2] + this[0, 1, 2, 1]);
      dummy[5, 4] = (this[0, 1, 0, 2] + this[0, 1, 2, 0]);
      dummy[5, 5] = (this[0, 1, 0, 1] + this[0, 1, 1, 0]);

      return (dummy);
    }
    public Tensor Conversion2ndTo4thOrderStiffness() //this is used to transform the stifness matrix(6,6) to the 4th order stiffnes tensor(3,3,3,3) 
    {
      if (order != 2 || n_lines != 6 || n_columns != 6)
      {
        throw new Exception("Tensor: Conversion2thTo4ndOrderStiffness(): invalid tensor size!!!");
      }
      double err;
      err = Constants.SMALL * Tensor.MinAbsNonZeroElement(this);

      if (Math.Abs(this[0, 1] - this[1, 0]) > err || Math.Abs(this[0, 2] - this[2, 0]) > err || Math.Abs(this[0, 3] - this[3, 0]) > err ||
          Math.Abs(this[0, 4] - this[4, 0]) > err || Math.Abs(this[0, 5] - this[5, 0]) > err || Math.Abs(this[1, 2] - this[2, 1]) > err ||
          Math.Abs(this[1, 3] - this[3, 1]) > err || Math.Abs(this[1, 4] - this[4, 1]) > err || Math.Abs(this[1, 5] - this[5, 1]) > err ||
          Math.Abs(this[2, 3] - this[3, 2]) > err || Math.Abs(this[2, 4] - this[4, 2]) > err || Math.Abs(this[2, 5] - this[5, 2]) > err ||
          Math.Abs(this[3, 4] - this[4, 3]) > err || Math.Abs(this[3, 5] - this[5, 3]) > err || Math.Abs(this[4, 5] - this[5, 4]) > err)
      {
        throw new Exception("Tensor: Conversion2thTo4ndOrderStiffness(): stiffness matrix is fully anisotropic!!!");
      }

      Tensor dummy = new Tensor(3, 3, 3, 3);

      dummy[0, 0, 0, 0] = this[0, 0];
      dummy[0, 0, 1, 1] = this[0, 1];
      dummy[0, 0, 2, 2] = this[0, 2];
      dummy[0, 0, 1, 2] = dummy[0, 0, 2, 1] = this[0, 3];
      dummy[0, 0, 0, 2] = dummy[0, 0, 2, 0] = this[0, 4];
      dummy[0, 0, 0, 1] = dummy[0, 0, 1, 0] = this[0, 5];

      dummy[1, 1, 0, 0] = this[1, 0];
      dummy[1, 1, 1, 1] = this[1, 1];
      dummy[1, 1, 2, 2] = this[1, 2];
      dummy[1, 1, 1, 2] = dummy[1, 1, 2, 1] = this[1, 3];
      dummy[1, 1, 0, 2] = dummy[1, 1, 2, 0] = this[1, 4];
      dummy[1, 1, 0, 1] = dummy[1, 1, 1, 0] = this[1, 5];

      dummy[2, 2, 0, 0] = this[2, 0];
      dummy[2, 2, 1, 1] = this[2, 1];
      dummy[2, 2, 2, 2] = this[2, 2];
      dummy[2, 2, 1, 2] = dummy[2, 2, 2, 1] = this[2, 3];
      dummy[2, 2, 0, 2] = dummy[2, 2, 2, 0] = this[2, 4];
      dummy[2, 2, 0, 1] = dummy[2, 2, 1, 0] = this[2, 5];

      dummy[1, 2, 0, 0] = dummy[2, 1, 0, 0] = this[3, 0];
      dummy[1, 2, 1, 1] = dummy[2, 1, 1, 1] = this[3, 1];
      dummy[1, 2, 2, 2] = dummy[2, 1, 2, 2] = this[3, 2];
      dummy[1, 2, 1, 2] = dummy[1, 2, 2, 1] = dummy[2, 1, 1, 2] = dummy[2, 1, 2, 1] = this[3, 3];
      dummy[1, 2, 0, 2] = dummy[1, 2, 2, 0] = dummy[2, 1, 0, 2] = dummy[2, 1, 2, 0] = this[3, 4];
      dummy[1, 2, 0, 1] = dummy[1, 2, 1, 0] = dummy[2, 1, 0, 1] = dummy[2, 1, 1, 0] = this[3, 5];

      dummy[0, 2, 0, 0] = dummy[2, 0, 0, 0] = this[4, 0];
      dummy[0, 2, 1, 1] = dummy[2, 0, 1, 1] = this[4, 1];
      dummy[0, 2, 2, 2] = dummy[2, 0, 2, 2] = this[4, 2];
      dummy[0, 2, 1, 2] = dummy[0, 2, 2, 1] = dummy[2, 0, 1, 2] = dummy[2, 0, 2, 1] = this[4, 3];
      dummy[0, 2, 0, 2] = dummy[0, 2, 2, 0] = dummy[2, 0, 0, 2] = dummy[2, 0, 2, 0] = this[4, 4];
      dummy[0, 2, 0, 1] = dummy[0, 2, 1, 0] = dummy[2, 0, 0, 1] = dummy[2, 0, 1, 0] = this[4, 5];

      dummy[0, 1, 0, 0] = dummy[1, 0, 0, 0] = this[5, 0];
      dummy[0, 1, 1, 1] = dummy[1, 0, 1, 1] = this[5, 1];
      dummy[0, 1, 2, 2] = dummy[1, 0, 2, 2] = this[5, 2];
      dummy[0, 1, 1, 2] = dummy[0, 1, 2, 1] = dummy[1, 0, 1, 2] = dummy[1, 0, 2, 1] = this[5, 3];
      dummy[0, 1, 0, 2] = dummy[0, 1, 2, 0] = dummy[1, 0, 0, 2] = dummy[1, 0, 2, 0] = this[5, 4];
      dummy[0, 1, 0, 1] = dummy[0, 1, 1, 0] = dummy[1, 0, 0, 1] = dummy[1, 0, 1, 0] = this[5, 5];

      return (dummy);
    }

    public Tensor Sort(out int sequence) //return a descending vector
    {
      if (order != 1 || n_lines != 3)
      {
        throw new Exception("Tensor: Sort: invalid tensor size!");
      }

      /* 0 1 2 3 4 5      = sequence
       ---------------
       | 0 0 1 2 1 2 |
       | 1 2 0 0 2 1 |
       | 2 1 2 1 0 0 | */

      Tensor a = new Tensor(this);
      double dummy;

      if (a[0] == a[1] && a[0] == a[2])
      {
        sequence = 0;
      }
      else if (a[0] == a[1])
      {
        if (a[0] > a[2])
        {
          sequence = 0;
        }
        else
        {
          dummy = a[0];
          a[0] = a[2];
          a[2] = dummy;
          sequence = 3;
        }
      }
      else if (a[0] == a[2])
      {
        if (a[0] > a[1])
        {
          dummy = a[1];
          a[1] = a[2];
          a[2] = dummy;
          sequence = 1;
        }
        else
        {
          dummy = a[0];
          a[0] = a[1];
          a[1] = dummy;
          sequence = 2;
        }
      }
      else if (a[1] == a[2])
      {
        if (a[1] > a[0])
        {
          dummy = a[0];
          a[0] = a[2];
          a[2] = dummy;
          sequence = 5;
        }
        else
        {
          sequence = 0;
        }
      }
      else if (a[0] > a[1] && a[0] > a[2])
      {
        if (a[1] > a[2])
        {
          sequence = 0;
        }
        else
        {
          dummy = a[1];
          a[1] = a[2];
          a[2] = dummy;
          sequence = 1;
        }
      }
      else if (a[1] > a[0] && a[1] > a[2])
      {
        if (a[0] > a[2])
        {
          dummy = a[0];
          a[0] = a[1];
          a[1] = dummy;
          sequence = 2;
        }
        else
        {
          dummy = a[0];
          a[0] = a[1];
          a[1] = a[2];
          a[2] = dummy;
          sequence = 4;
        }
      }
      else
      {
        if (a[0] > a[1])
        {
          dummy = a[0];
          a[0] = a[2];
          a[2] = a[1];
          a[1] = dummy;
          sequence = 3;
        }
        else
        {
          dummy = a[0];
          a[0] = a[2];
          a[2] = dummy;
          sequence = 5;
        }
      }
      return (a);
    }
    public static Tensor Sort(double x0, double x1, double x2, out int sequence) //return a descending vector
    {

      /* 0 1 2 3 4 5      = sequence
       ---------------
       | 0 0 1 2 1 2 |
       | 1 2 0 0 2 1 |
       | 2 1 2 1 0 0 | */

      Tensor a = new Tensor(3);
      a[0] = x0;
      a[1] = x1;
      a[2] = x2;

      return (a.Sort(out sequence));
    }
    public Tensor Unsort(int sequence)
    {
      Tensor A = new Tensor(this);
      double dummy;

      if (A.order == 1 && A.n_lines == 3)
      {
        switch (sequence)
        {
          case 0:
            break;

          case 1:
            dummy = A[1];
            A[1] = A[2];
            A[2] = dummy;
            break;

          case 2:
            dummy = A[0];
            A[0] = A[1];
            A[1] = dummy;
            break;

          case 3:
            dummy = A[0];
            A[0] = A[1];
            A[1] = A[2];
            A[2] = dummy;
            break;

          case 4:
            dummy = A[0];
            A[0] = A[2];
            A[2] = A[1];
            A[1] = dummy;
            break;

          case 5:
            dummy = A[0];
            A[0] = A[2];
            A[2] = dummy;
            break;

          default:
            throw new Exception("Inclusion: Unsort: wrong sequence!");
        }
      }
      else if (A.order == 2 && A.n_lines == 3 && A.n_columns == 3)
      {
        if (A.x[1] == 0 && A.x[2] == 0 && A.x[3] == 0 && A.x[5] == 0 && A.x[6] == 0 && A.x[7] == 0)
        {
          switch (sequence)
          {
            case 0:
              break;

            case 1:
              dummy = A[1, 1];
              A[1, 1] = A[2, 2];
              A[2, 2] = dummy;
              break;

            case 2:
              dummy = A[0, 0];
              A[0, 0] = A[1, 1];
              A[1, 1] = dummy;
              break;

            case 3:
              dummy = A[0, 0];
              A[0, 0] = A[1, 1];
              A[1, 1] = A[2, 2];
              A[2, 2] = dummy;
              break;

            case 4:
              dummy = A[0, 0];
              A[0, 0] = A[2, 2];
              A[2, 2] = A[1, 1];
              A[1, 1] = dummy;
              break;

            case 5:
              dummy = A[0, 0];
              A[0, 0] = A[2, 2];
              A[2, 2] = dummy;
              break;

            default:
              throw new Exception("Tensor: Unsort: wrong sequence!");
          }
        }
        else
        {
          int[] i = new int[3];
          int k = 0;

          switch (sequence)
          {
            case 0:
              k = 0;
              break;

            case 1:
              i[0] = 1;
              i[1] = 2;
              k = 2;
              break;

            case 2:
              i[0] = 0;
              i[1] = 1;
              k = 2;
              break;

            case 3:
              i[0] = 0;
              i[1] = 1;
              i[2] = 2;
              k = 3;
              break;

            case 4:
              i[0] = 0;
              i[1] = 2;
              i[2] = 1;
              k = 3;
              break;

            case 5:
              i[0] = 0;
              i[1] = 2;
              k = 2;
              break;

            default:
              throw new Exception("Inclusion: Unsort: wrong sequence!");
          }

          int jj;

          for (int ii = 0; ii < k - 1; ii++)
          {
            // change of rows
            for (jj = 0; jj < 6; jj++)
            {
              dummy = A[i[ii], jj];
              A[i[ii], jj] = A[i[ii + 1], jj];
              A[i[ii + 1], jj] = dummy;
            }
            // change of columns
            for (jj = 0; jj < 6; jj++)
            {
              dummy = A[jj, i[ii]];
              A[jj, i[ii]] = A[jj, i[ii + 1]];
              A[jj, i[ii + 1]] = dummy;
            }
          }
        }
      }
      else if (A.order == 2 && A.n_lines == 6 && A.n_columns == 6)   // for elasticity (stiffness matrix, etc.)
      {
        int[] i = new int[3];
        int[] j = new int[3];
        int k = 0;

        switch (sequence)
        {
          case 0:
            k = 0;
            break;

          case 1:
            i[0] = 1;
            i[1] = 2;
            j[0] = 4;
            j[1] = 5;
            k = 2;
            break;

          case 2:
            i[0] = 0;
            i[1] = 1;
            j[0] = 3;
            j[1] = 4;
            k = 2;
            break;

          case 3:
            i[0] = 0;
            i[1] = 1;
            i[2] = 2;
            j[0] = 3;
            j[1] = 4;
            j[2] = 5;
            k = 3;
            break;

          case 4:
            i[0] = 0;
            i[1] = 2;
            i[2] = 1;
            j[0] = 3;
            j[1] = 5;
            j[2] = 4;
            k = 3;
            break;

          case 5:
            i[0] = 0;
            i[1] = 2;
            j[0] = 3;
            j[1] = 5;
            k = 2;
            break;

          default:
            throw new Exception("Inclusion: Unsort: wrong sequence!");
        }

        int jj;

        for (int ii = 0; ii < k - 1; ii++)
        {
          // change of rows
          for (jj = 0; jj < 6; jj++)
          {
            dummy = A[i[ii], jj];
            A[i[ii], jj] = A[i[ii+1], jj];
            A[i[ii+1], jj] = dummy;

            dummy = A[j[ii], jj];
            A[j[ii], jj] = A[j[ii + 1], jj];
            A[j[ii + 1], jj] = dummy;
          }
          // change of columns
          for (jj = 0; jj < 6; jj++)
          {
            dummy = A[jj, i[ii]];
            A[jj, i[ii]] = A[jj, i[ii + 1]];
            A[jj, i[ii + 1]] = dummy;

            dummy = A[jj, j[ii]];
            A[jj, j[ii]] = A[jj, j[ii + 1]];
            A[jj, j[ii + 1]] = dummy;
          }
        }
      }
      else
      {
        throw new Exception("Tensor: Unsort: wrong tensor!");
      }

      return (A);         
    }

    public bool IsDiagonal
    {
      get
      {
        if (order != 2 || n_lines != n_columns)
        {
          throw new Exception("Tensor: IsDiagonal: wrong tensor order!");
        }
        for (int i = 0; i < n_lines; i++)
          for (int j = 0; j < n_lines; j++)
          {
            if (this.value(i, j) != 0 && i != j)
            {
              return (false);
            }
          }
        return (true);
      }
    }

    public static Tensor ConstantTensorProduct(double oalpha, Tensor oright)
    {

      int i, j, k, l;

      Tensor MUL = new Tensor(oright);

      switch (MUL.which_order)
      {
        case 1:
          for (i = 0; i < oright.how_many_lines; i++)
          {
            if (!(oalpha < Constants.ZERO && oright[i] == Constants.INFINITY) &&
                !(oalpha == Constants.INFINITY && Math.Abs(oright[i]) < Constants.ZERO))
            {
              MUL[i] = oalpha * oright[i];
            }
          }
          break;
        case 2:
          for (i = 0; i < oright.how_many_lines; i++)
          {
            for (j = 0; j < oright.how_many_columns; j++)
            {
              if (!(oalpha < Constants.ZERO && oright[i, j] == Constants.INFINITY) &&
                  !(oalpha == Constants.INFINITY && Math.Abs(oright[i, j]) < Constants.ZERO))
              {
                MUL[i, j] = oalpha * oright[i, j];
              }
            }
          }
          break;
        case 3:
          for (i = 0; i < oright.how_many_lines; i++)
          {
            for (j = 0; j < oright.how_many_columns; j++)
            {
              for (k = 0; k < oright.how_many_lines2; k++)
              {
                if (!(oalpha < Constants.ZERO && oright[i, j, k] == Constants.INFINITY) &&
                    !(oalpha == Constants.INFINITY && Math.Abs(oright[i, j, k]) < Constants.ZERO))
                {
                  MUL[i, j, k] = oalpha * oright[i, j, k];
                }
              }
            }
          }
          break;
        case 4:
          for (i = 0; i < oright.how_many_lines; i++)
          {
            for (j = 0; j < oright.how_many_columns; j++)
            {
              for (k = 0; k < oright.how_many_lines2; k++)
              {
                for (l = 0; l < oright.how_many_columns2; l++)
                {
                  if (!(oalpha < Constants.ZERO && oright[i, j, k, l] == Constants.INFINITY) &&
                      !(oalpha == Constants.INFINITY && Math.Abs(oright[i, j, k, l]) < Constants.ZERO))
                  {
                    MUL[i, j, k, l] = oalpha * oright[i, j, k, l];
                  }
                }
              }
            }
          }
          break;
        default:
          throw new Exception("Tensor: operator*: invalid Tensors order!");
      }
      return MUL;
    }
    public static Tensor TensorTensorProduct(Tensor oleft, Tensor oright)     //INFINITY*ZERO=ZERO
    {

      if (oleft.which_order == 2 && oright.which_order == 2)
      {
        if ((oleft.how_many_columns != oright.how_many_lines))
        {
          throw new Exception("Tensor: operator*: invalid Tensors size!");
        }
      }

      if (oleft.which_order == 2 && oright.which_order == 1)
      {
        if (((oleft.how_many_columns != oright.how_many_lines)))
        {
          throw new Exception("Tensor: operator*: invalid Tensors size!");
        }
      }

      int i, j, k;

      Tensor PROD = new Tensor(oleft.how_many_lines, oright.how_many_columns);

      switch (PROD.which_order)
      {
        case 1:
          for (i = 0; i < oleft.how_many_lines; i++)
          {
            for (k = 0; k < oleft.how_many_columns; k++)
            {
              if (!(Math.Abs(oleft[i, k]) < Constants.ZERO && oright[k] == Constants.INFINITY) &&
                  !(oleft[i, k] == Constants.INFINITY && Math.Abs(oright[k]) < Constants.ZERO))
              {
                PROD[i] += oleft[i, k] * oright[k];
              }
            }
          }


          break;
        case 2:
          for (i = 0; i < oleft.how_many_lines; i++)
          {
            for (j = 0; j < oright.how_many_columns; j++)
            {
              for (k = 0; k < oleft.how_many_columns; k++)
              {
                if (!(Math.Abs(oleft[i, k]) < Constants.ZERO && oright[k, j] == Constants.INFINITY) &&
                    !(oleft[i, k] == Constants.INFINITY && Math.Abs(oright[k, j]) < Constants.ZERO))
                {
                  PROD[i, j] += oleft[i, k] * oright[k, j];
                }
              }
            }
          }
          break;
        case 4:
          throw new Exception("Tensor: operator*: 4th order not defined yet!");
        default:
          throw new Exception("Tensor: operator*: invalid Tensors order!");
      }
      return PROD;
    }

    public XmlElement ToXml(XmlDocument xmldoc, string name)
    {
      XmlElement _tensor = xmldoc.CreateElement("tensor");
      XmlAttribute _atrib = xmldoc.CreateAttribute("name");

      _atrib.Value = name;
      _tensor.SetAttributeNode(_atrib);

      _atrib = xmldoc.CreateAttribute("order");
      _atrib.Value = Convert.ToString(order, Constants.Separators.FormatProvider);
      _tensor.SetAttributeNode(_atrib);

      XmlElement _array = xmldoc.CreateElement("array");
      XmlElement _text;

      switch (which_order)
      {
        case 1:
          _text = xmldoc.CreateElement("lines");
          _text.InnerText = Convert.ToString(how_many_lines, Constants.Separators.FormatProvider);
          _tensor.AppendChild(_text);

          for (int i = 0; i < how_many_lines; i++)
          {
            _text = xmldoc.CreateElement("elem_" + Convert.ToString(i, Constants.Separators.FormatProvider));
            _text.InnerText = Convert.ToString(this[i], Constants.Separators.FormatProvider);
            _array.AppendChild(_text);
          }
          break;

        case 2:
          _text = xmldoc.CreateElement("lines");
          _text.InnerText = Convert.ToString(how_many_lines, Constants.Separators.FormatProvider);
          _tensor.AppendChild(_text);
          _text = xmldoc.CreateElement("columns");
          _text.InnerText = Convert.ToString(how_many_columns, Constants.Separators.FormatProvider);
          _tensor.AppendChild(_text);

          for (int i = 0; i < how_many_lines; i++)
          {
            for (int j = 0; j < how_many_lines; j++)
            {
              _text = xmldoc.CreateElement("elem_" + Convert.ToString(i, Constants.Separators.FormatProvider) 
                                           + Convert.ToString(j, Constants.Separators.FormatProvider));
              _text.InnerText = Convert.ToString(this[i, j], Constants.Separators.FormatProvider);
              _array.AppendChild(_text);
            }
          }
          break;

        case 3:
          _text = xmldoc.CreateElement("lines");
          _text.InnerText = Convert.ToString(how_many_lines, Constants.Separators.FormatProvider);
          _tensor.AppendChild(_text);
          _text = xmldoc.CreateElement("columns");
          _text.InnerText = Convert.ToString(how_many_columns, Constants.Separators.FormatProvider);
          _tensor.AppendChild(_text);
          _text = xmldoc.CreateElement("lines2");
          _text.InnerText = Convert.ToString(how_many_lines2, Constants.Separators.FormatProvider);
          _tensor.AppendChild(_text);

          for (int i = 0; i < how_many_lines; i++)
          {
            for (int j = 0; j < how_many_columns; j++)
            {
              for (int k = 0; k < how_many_lines2; k++)
              {
                _text = xmldoc.CreateElement("elem_" + Convert.ToString(i, Constants.Separators.FormatProvider)
                                             + Convert.ToString(j, Constants.Separators.FormatProvider)
                                             + Convert.ToString(k, Constants.Separators.FormatProvider));
                _text.InnerText = Convert.ToString(this[i, j, k], Constants.Separators.FormatProvider);
                _array.AppendChild(_text);
              }
            }
          }
          break;

        case 4:
          _text = xmldoc.CreateElement("lines");
          _text.InnerText = Convert.ToString(how_many_lines, Constants.Separators.FormatProvider);
          _tensor.AppendChild(_text);
          _text = xmldoc.CreateElement("columns");
          _text.InnerText = Convert.ToString(how_many_columns, Constants.Separators.FormatProvider);
          _tensor.AppendChild(_text);
          _text = xmldoc.CreateElement("lines2");
          _text.InnerText = Convert.ToString(how_many_lines2, Constants.Separators.FormatProvider);
          _tensor.AppendChild(_text);
          _text = xmldoc.CreateElement("columns2");
          _text.InnerText = Convert.ToString(how_many_columns2, Constants.Separators.FormatProvider);
          _tensor.AppendChild(_text);

          for (int i = 0; i < how_many_lines; i++)
          {
            for (int j = 0; j < how_many_columns; j++)
            {
              for (int k = 0; k < how_many_lines2; k++)
              {
                for (int l = 0; l < how_many_columns2; l++)
                {
                  _text = xmldoc.CreateElement("elem_" + Convert.ToString(i, Constants.Separators.FormatProvider)
                                                       + Convert.ToString(j, Constants.Separators.FormatProvider)
                                                       + Convert.ToString(k, Constants.Separators.FormatProvider)
                                                       + Convert.ToString(l, Constants.Separators.FormatProvider));
                  _text.InnerText = Convert.ToString(this[i, j, k, l], Constants.Separators.FormatProvider);
                  _array.AppendChild(_text);
                }
              }
            }
          }
          break;

        default:
          throw new Exception("Save: MatrixToXml: invalid Tensors order!");
      }

      _tensor.AppendChild(_array);

      return (_tensor);
    }
    public string FromXml(XmlNode xmlnode)
    {
      this.Clear();

      string name = "new tensor";
      int order = -1;
      int lines;
      int columns;
      ////int lines2;   //for 3rd and 4th order
      ////int columns2;


      for (int i = 0; i < xmlnode.Attributes.Count; i++)
      {
        if (xmlnode.Attributes[i].Name == "name")
        {
          name = xmlnode.Attributes[i].Value;
        }
        else if (xmlnode.Attributes[i].Name == "order")
        {
          if (!(int.TryParse(xmlnode.Attributes[i].Value, out order)) || !(this.order == order))
          {
            throw new Exception("xml: tensor: wrong order!!!");
          }
        }
      }

      switch (order)
      {
        case 1:
          if (!(xmlnode.ChildNodes.Count == 2))
          {
            throw new Exception("xml: tensor: 1: wrong nubber of nodes for tensor order!!!");
          }

          if (xmlnode.ChildNodes[0].Name == "lines")
          {
            if (!(int.TryParse(xmlnode.ChildNodes[0].InnerText, out lines)) || !(this.n_lines == lines))
            {
              throw new Exception("xml: tensor: 1: wrong lines!!!");
            }
          }
          else
          {
            throw new Exception("xml: tensor: 1: wrong node tag!!!");
          }

          if ((xmlnode.ChildNodes[1].Name == "array"))
          {
            if (!(xmlnode.ChildNodes[1].ChildNodes.Count == lines))
            {
              throw new Exception("xml: tensor: 1: wrong number of elements in array!!!");
            }
            for (int i = 0; i < lines; i++)
            {
              if (!(xmlnode.ChildNodes[1].ChildNodes[i].Name == ("elem_" + Convert.ToString(i, Constants.Separators.FormatProvider))))
              {
                throw new Exception("xml: tensor: 1: wrong name of element in array!!!");
              }
              else
              {
                this.x[i] = Functions.StringToDouble(xmlnode.ChildNodes[1].ChildNodes[i].InnerText, "xml: tensor: 1: wrong element!!!");
              }
            }
          }
          else
          {
            throw new Exception("xml: tensor: 1: wrong node tag!!!");
          }
          break;

        case 2:
          if (!(xmlnode.ChildNodes.Count == 3))
          {
            throw new Exception("xml: tensor: 2: wrong nubber of nodes for tensor order!!!");
          }

          if (xmlnode.ChildNodes[0].Name == "lines")
          {
            if (!(int.TryParse(xmlnode.ChildNodes[0].InnerText, out lines)) || !(this.n_lines == lines))
            {
              throw new Exception("xml: tensor: 2: wrong lines!!!");
            }
          }
          else
          {
            throw new Exception("xml: tensor: 2: wrong node tag!!!");
          }

          if (xmlnode.ChildNodes[1].Name == "columns")
          {
            if (!(int.TryParse(xmlnode.ChildNodes[1].InnerText, out columns)) || !(this.n_columns == columns))
            {
              throw new Exception("xml: tensor: 2: wrong columns!!!");
            }
          }
          else
          {
            throw new Exception("xml: tensor: 2: wrong node tag!!!");
          }

          if ((xmlnode.ChildNodes[2].Name == "array"))
          {
            if (!(xmlnode.ChildNodes[2].ChildNodes.Count == (lines * columns)))
            {
              throw new Exception("xml: tensor: 2: wrong number of elements in array!!!");
            }
            for (int i = 0; i < lines; i++)
            {
              for (int j = 0; j < columns; j++)
              {
                if (!(xmlnode.ChildNodes[2].ChildNodes[i * columns + j].Name ==
                     ("elem_" + Convert.ToString(i, Constants.Separators.FormatProvider) + Convert.ToString(j, Constants.Separators.FormatProvider))))
                {
                  throw new Exception("xml: tensor: 2: wrong name of element in array!!!");
                }
                else
                {
                  this.x[i * columns + j] = Functions.StringToDouble(xmlnode.ChildNodes[2].ChildNodes[i * columns + j].InnerText, "xml: tensor: 2: wrong element!!!"); 
                }
              }
            }
          }
          else
          {
            throw new Exception("xml: tensor: 1: wrong node tag!!!");
          }
          break;

        case 3:
          throw new Exception("xml: tensor: 3: code in progress, just do it alone!!!");

        case 4:
          throw new Exception("xml: tensor: 4: code in progress, just do it alone!!!");

        default:
          throw new Exception("xml: tensor: wrong order!!!");
      }

      return name;
    }

    public static Tensor PermutationTensor()
    {
      Tensor a = new Tensor(3, 3, 3);

      a[0, 1, 2] = a[1, 2, 0] = a[2, 0, 1] = 1;
      a[0, 2, 1] = a[2, 1, 0] = a[1, 0, 2] = -1;

      return a;
    }
  }
 }



